/* financial.c generated by valac 0.56.15, the Vala compiler
 * generated from financial.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "calculator.h"
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

VALA_EXTERN Number* calc_ctrm (MathEquation* equation,
                   Number* pint,
                   Number* fv,
                   Number* pv);
VALA_EXTERN Number* calc_ddb (MathEquation* equation,
                  Number* cost,
                  Number* life,
                  Number* period);
VALA_EXTERN Number* calc_fv (MathEquation* equation,
                 Number* pmt,
                 Number* pint,
                 Number* n);
VALA_EXTERN Number* calc_gpm (MathEquation* equation,
                  Number* cost,
                  Number* margin);
VALA_EXTERN Number* calc_pmt (MathEquation* equation,
                  Number* prin,
                  Number* pint,
                  Number* n);
VALA_EXTERN Number* calc_pv (MathEquation* equation,
                 Number* pmt,
                 Number* pint,
                 Number* n);
VALA_EXTERN Number* calc_rate (MathEquation* equation,
                   Number* fv,
                   Number* pv,
                   Number* n);
VALA_EXTERN Number* calc_sln (MathEquation* equation,
                  Number* cost,
                  Number* salvage,
                  Number* life);
VALA_EXTERN Number* calc_syd (MathEquation* equation,
                  Number* cost,
                  Number* salvage,
                  Number* life,
                  Number* period);
VALA_EXTERN Number* calc_term (MathEquation* equation,
                   Number* pmt,
                   Number* fv,
                   Number* pint);

static GType
financial_dialog_get_type_once (void)
{
	static const GEnumValue values[] = {{FINANCIAL_DIALOG_CTRM_DIALOG, "FINANCIAL_DIALOG_CTRM_DIALOG", "ctrm-dialog"}, {FINANCIAL_DIALOG_DDB_DIALOG, "FINANCIAL_DIALOG_DDB_DIALOG", "ddb-dialog"}, {FINANCIAL_DIALOG_FV_DIALOG, "FINANCIAL_DIALOG_FV_DIALOG", "fv-dialog"}, {FINANCIAL_DIALOG_GPM_DIALOG, "FINANCIAL_DIALOG_GPM_DIALOG", "gpm-dialog"}, {FINANCIAL_DIALOG_PMT_DIALOG, "FINANCIAL_DIALOG_PMT_DIALOG", "pmt-dialog"}, {FINANCIAL_DIALOG_PV_DIALOG, "FINANCIAL_DIALOG_PV_DIALOG", "pv-dialog"}, {FINANCIAL_DIALOG_RATE_DIALOG, "FINANCIAL_DIALOG_RATE_DIALOG", "rate-dialog"}, {FINANCIAL_DIALOG_SLN_DIALOG, "FINANCIAL_DIALOG_SLN_DIALOG", "sln-dialog"}, {FINANCIAL_DIALOG_SYD_DIALOG, "FINANCIAL_DIALOG_SYD_DIALOG", "syd-dialog"}, {FINANCIAL_DIALOG_TERM_DIALOG, "FINANCIAL_DIALOG_TERM_DIALOG", "term-dialog"}, {0, NULL, NULL}};
	GType financial_dialog_type_id;
	financial_dialog_type_id = g_enum_register_static ("FinancialDialog", values);
	return financial_dialog_type_id;
}

GType
financial_dialog_get_type (void)
{
	static volatile gsize financial_dialog_type_id__once = 0;
	if (g_once_init_enter (&financial_dialog_type_id__once)) {
		GType financial_dialog_type_id;
		financial_dialog_type_id = financial_dialog_get_type_once ();
		g_once_init_leave (&financial_dialog_type_id__once, financial_dialog_type_id);
	}
	return financial_dialog_type_id__once;
}

void
do_finc_expression (MathEquation* equation,
                    FinancialDialog function,
                    Number* arg1,
                    Number* arg2,
                    Number* arg3,
                    Number* arg4)
{
	Number* _result_ = NULL;
	Number* _tmp11_;
#line 26 "../lib/financial.vala"
	g_return_if_fail (equation != NULL);
#line 26 "../lib/financial.vala"
	g_return_if_fail (arg1 != NULL);
#line 26 "../lib/financial.vala"
	g_return_if_fail (arg2 != NULL);
#line 26 "../lib/financial.vala"
	g_return_if_fail (arg3 != NULL);
#line 26 "../lib/financial.vala"
	g_return_if_fail (arg4 != NULL);
#line 29 "../lib/financial.vala"
	switch (function) {
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_CTRM_DIALOG:
#line 117 "financial.c"
		{
			Number* _tmp0_;
#line 32 "../lib/financial.vala"
			_tmp0_ = calc_ctrm (equation, arg1, arg2, arg3);
#line 32 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 32 "../lib/financial.vala"
			_result_ = _tmp0_;
#line 33 "../lib/financial.vala"
			break;
#line 128 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_DDB_DIALOG:
#line 132 "financial.c"
		{
			Number* _tmp1_;
#line 35 "../lib/financial.vala"
			_tmp1_ = calc_ddb (equation, arg1, arg2, arg3);
#line 35 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 35 "../lib/financial.vala"
			_result_ = _tmp1_;
#line 36 "../lib/financial.vala"
			break;
#line 143 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_FV_DIALOG:
#line 147 "financial.c"
		{
			Number* _tmp2_;
#line 38 "../lib/financial.vala"
			_tmp2_ = calc_fv (equation, arg1, arg2, arg3);
#line 38 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 38 "../lib/financial.vala"
			_result_ = _tmp2_;
#line 39 "../lib/financial.vala"
			break;
#line 158 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_GPM_DIALOG:
#line 162 "financial.c"
		{
			Number* _tmp3_;
#line 41 "../lib/financial.vala"
			_tmp3_ = calc_gpm (equation, arg1, arg2);
#line 41 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 41 "../lib/financial.vala"
			_result_ = _tmp3_;
#line 42 "../lib/financial.vala"
			break;
#line 173 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_PMT_DIALOG:
#line 177 "financial.c"
		{
			Number* _tmp4_;
#line 44 "../lib/financial.vala"
			_tmp4_ = calc_pmt (equation, arg1, arg2, arg3);
#line 44 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 44 "../lib/financial.vala"
			_result_ = _tmp4_;
#line 45 "../lib/financial.vala"
			break;
#line 188 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_PV_DIALOG:
#line 192 "financial.c"
		{
			Number* _tmp5_;
#line 47 "../lib/financial.vala"
			_tmp5_ = calc_pv (equation, arg1, arg2, arg3);
#line 47 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 47 "../lib/financial.vala"
			_result_ = _tmp5_;
#line 48 "../lib/financial.vala"
			break;
#line 203 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_RATE_DIALOG:
#line 207 "financial.c"
		{
			Number* _tmp6_;
#line 50 "../lib/financial.vala"
			_tmp6_ = calc_rate (equation, arg1, arg2, arg3);
#line 50 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 50 "../lib/financial.vala"
			_result_ = _tmp6_;
#line 51 "../lib/financial.vala"
			break;
#line 218 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_SLN_DIALOG:
#line 222 "financial.c"
		{
			Number* _tmp7_;
#line 53 "../lib/financial.vala"
			_tmp7_ = calc_sln (equation, arg1, arg2, arg3);
#line 53 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 53 "../lib/financial.vala"
			_result_ = _tmp7_;
#line 54 "../lib/financial.vala"
			break;
#line 233 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_SYD_DIALOG:
#line 237 "financial.c"
		{
			Number* _tmp8_;
#line 56 "../lib/financial.vala"
			_tmp8_ = calc_syd (equation, arg1, arg2, arg3, arg4);
#line 56 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 56 "../lib/financial.vala"
			_result_ = _tmp8_;
#line 57 "../lib/financial.vala"
			break;
#line 248 "financial.c"
		}
#line 29 "../lib/financial.vala"
		case FINANCIAL_DIALOG_TERM_DIALOG:
#line 252 "financial.c"
		{
			Number* _tmp9_;
#line 59 "../lib/financial.vala"
			_tmp9_ = calc_term (equation, arg1, arg2, arg3);
#line 59 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 59 "../lib/financial.vala"
			_result_ = _tmp9_;
#line 60 "../lib/financial.vala"
			break;
#line 263 "financial.c"
		}
		default:
		{
			Number* _tmp10_;
#line 62 "../lib/financial.vala"
			_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 62 "../lib/financial.vala"
			_g_object_unref0 (_result_);
#line 62 "../lib/financial.vala"
			_result_ = _tmp10_;
#line 63 "../lib/financial.vala"
			break;
#line 276 "financial.c"
		}
	}
#line 66 "../lib/financial.vala"
	_tmp11_ = _result_;
#line 66 "../lib/financial.vala"
	math_equation_set_number (equation, _tmp11_, TRUE, (guint) 0);
#line 26 "../lib/financial.vala"
	_g_object_unref0 (_result_);
#line 285 "financial.c"
}

Number*
calc_ctrm (MathEquation* equation,
           Number* pint,
           Number* fv,
           Number* pv)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* t2 = NULL;
	Number* _tmp1_;
	Number* t3 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t4 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* result;
#line 69 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 69 "../lib/financial.vala"
	g_return_val_if_fail (pint != NULL, NULL);
#line 69 "../lib/financial.vala"
	g_return_val_if_fail (fv != NULL, NULL);
#line 69 "../lib/financial.vala"
	g_return_val_if_fail (pv != NULL, NULL);
#line 77 "../lib/financial.vala"
	_tmp0_ = number_divide (fv, pv);
#line 77 "../lib/financial.vala"
	t1 = _tmp0_;
#line 78 "../lib/financial.vala"
	_tmp1_ = number_ln (t1);
#line 78 "../lib/financial.vala"
	t2 = _tmp1_;
#line 79 "../lib/financial.vala"
	_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 79 "../lib/financial.vala"
	_tmp3_ = _tmp2_;
#line 79 "../lib/financial.vala"
	_tmp4_ = number_add (pint, _tmp3_);
#line 79 "../lib/financial.vala"
	_tmp5_ = _tmp4_;
#line 79 "../lib/financial.vala"
	_g_object_unref0 (_tmp3_);
#line 79 "../lib/financial.vala"
	t3 = _tmp5_;
#line 80 "../lib/financial.vala"
	_tmp6_ = number_ln (t3);
#line 80 "../lib/financial.vala"
	t4 = _tmp6_;
#line 81 "../lib/financial.vala"
	_tmp7_ = number_divide (t2, t4);
#line 81 "../lib/financial.vala"
	result = _tmp7_;
#line 81 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 81 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 81 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 81 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 81 "../lib/financial.vala"
	return result;
#line 353 "financial.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 109 "../lib/financial.vala"
	return self ? g_object_ref (self) : NULL;
#line 361 "financial.c"
}

Number*
calc_ddb (MathEquation* equation,
          Number* cost,
          Number* life,
          Number* period)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* tbv = NULL;
	Number* _tmp1_;
	gint64 len = 0LL;
	Number* result;
#line 84 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 84 "../lib/financial.vala"
	g_return_val_if_fail (cost != NULL, NULL);
#line 84 "../lib/financial.vala"
	g_return_val_if_fail (life != NULL, NULL);
#line 84 "../lib/financial.vala"
	g_return_val_if_fail (period != NULL, NULL);
#line 100 "../lib/financial.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 100 "../lib/financial.vala"
	z = _tmp0_;
#line 102 "../lib/financial.vala"
	_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 102 "../lib/financial.vala"
	tbv = _tmp1_;
#line 103 "../lib/financial.vala"
	len = number_to_integer (period);
#line 394 "financial.c"
	{
		gint i = 0;
#line 104 "../lib/financial.vala"
		i = 0;
#line 399 "financial.c"
		{
			gboolean _tmp2_ = FALSE;
#line 104 "../lib/financial.vala"
			_tmp2_ = TRUE;
#line 104 "../lib/financial.vala"
			while (TRUE) {
#line 406 "financial.c"
				Number* t1 = NULL;
				Number* _tmp4_;
				Number* _tmp5_;
				Number* t2 = NULL;
				Number* _tmp6_;
				Number* _tmp7_;
				Number* _tmp8_;
				Number* _tmp9_;
				Number* _tmp10_;
				Number* _tmp11_;
				Number* _tmp12_;
				Number* _tmp13_;
				Number* _tmp14_;
#line 104 "../lib/financial.vala"
				if (!_tmp2_) {
#line 422 "financial.c"
					gint _tmp3_;
#line 104 "../lib/financial.vala"
					_tmp3_ = i;
#line 104 "../lib/financial.vala"
					i = _tmp3_ + 1;
#line 428 "financial.c"
				}
#line 104 "../lib/financial.vala"
				_tmp2_ = FALSE;
#line 104 "../lib/financial.vala"
				if (!(((gint64) i) < len)) {
#line 104 "../lib/financial.vala"
					break;
#line 436 "financial.c"
				}
#line 106 "../lib/financial.vala"
				_tmp4_ = tbv;
#line 106 "../lib/financial.vala"
				_tmp5_ = number_subtract (cost, _tmp4_);
#line 106 "../lib/financial.vala"
				t1 = _tmp5_;
#line 107 "../lib/financial.vala"
				_tmp6_ = t1;
#line 107 "../lib/financial.vala"
				_tmp7_ = number_multiply_integer (_tmp6_, (gint64) 2);
#line 107 "../lib/financial.vala"
				t2 = _tmp7_;
#line 108 "../lib/financial.vala"
				_tmp8_ = t2;
#line 108 "../lib/financial.vala"
				_tmp9_ = number_divide (_tmp8_, life);
#line 108 "../lib/financial.vala"
				_g_object_unref0 (z);
#line 108 "../lib/financial.vala"
				z = _tmp9_;
#line 109 "../lib/financial.vala"
				_tmp10_ = tbv;
#line 109 "../lib/financial.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 109 "../lib/financial.vala"
				_g_object_unref0 (t1);
#line 109 "../lib/financial.vala"
				t1 = _tmp11_;
#line 110 "../lib/financial.vala"
				_tmp12_ = t1;
#line 110 "../lib/financial.vala"
				_tmp13_ = z;
#line 110 "../lib/financial.vala"
				_tmp14_ = number_add (_tmp12_, _tmp13_);
#line 110 "../lib/financial.vala"
				_g_object_unref0 (tbv);
#line 110 "../lib/financial.vala"
				tbv = _tmp14_;
#line 104 "../lib/financial.vala"
				_g_object_unref0 (t2);
#line 104 "../lib/financial.vala"
				_g_object_unref0 (t1);
#line 480 "financial.c"
			}
		}
	}
#line 113 "../lib/financial.vala"
	if (len >= ((gint64) 0)) {
#line 114 "../lib/financial.vala"
		math_equation_set_status (equation, _ ("Error: the number of periods must be positive"));
#line 488 "financial.c"
	}
#line 116 "../lib/financial.vala"
	result = z;
#line 116 "../lib/financial.vala"
	_g_object_unref0 (tbv);
#line 116 "../lib/financial.vala"
	return result;
#line 496 "financial.c"
}

Number*
calc_fv (MathEquation* equation,
         Number* pmt,
         Number* pint,
         Number* n)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* t2 = NULL;
	Number* _tmp4_;
	Number* t3 = NULL;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* t4 = NULL;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* result;
#line 119 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 119 "../lib/financial.vala"
	g_return_val_if_fail (pmt != NULL, NULL);
#line 119 "../lib/financial.vala"
	g_return_val_if_fail (pint != NULL, NULL);
#line 119 "../lib/financial.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 128 "../lib/financial.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 128 "../lib/financial.vala"
	_tmp1_ = _tmp0_;
#line 128 "../lib/financial.vala"
	_tmp2_ = number_add (pint, _tmp1_);
#line 128 "../lib/financial.vala"
	_tmp3_ = _tmp2_;
#line 128 "../lib/financial.vala"
	_g_object_unref0 (_tmp1_);
#line 128 "../lib/financial.vala"
	t1 = _tmp3_;
#line 129 "../lib/financial.vala"
	_tmp4_ = number_xpowy (t1, n);
#line 129 "../lib/financial.vala"
	t2 = _tmp4_;
#line 130 "../lib/financial.vala"
	_tmp5_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 130 "../lib/financial.vala"
	_tmp6_ = _tmp5_;
#line 130 "../lib/financial.vala"
	_tmp7_ = number_add (t2, _tmp6_);
#line 130 "../lib/financial.vala"
	_tmp8_ = _tmp7_;
#line 130 "../lib/financial.vala"
	_g_object_unref0 (_tmp6_);
#line 130 "../lib/financial.vala"
	t3 = _tmp8_;
#line 131 "../lib/financial.vala"
	_tmp9_ = number_multiply (pmt, t3);
#line 131 "../lib/financial.vala"
	t4 = _tmp9_;
#line 132 "../lib/financial.vala"
	_tmp10_ = number_divide (t4, pint);
#line 132 "../lib/financial.vala"
	result = _tmp10_;
#line 132 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 132 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 132 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 132 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 132 "../lib/financial.vala"
	return result;
#line 575 "financial.c"
}

Number*
calc_gpm (MathEquation* equation,
          Number* cost,
          Number* margin)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* t2 = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* result;
#line 135 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 135 "../lib/financial.vala"
	g_return_val_if_fail (cost != NULL, NULL);
#line 135 "../lib/financial.vala"
	g_return_val_if_fail (margin != NULL, NULL);
#line 143 "../lib/financial.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 143 "../lib/financial.vala"
	t1 = _tmp0_;
#line 144 "../lib/financial.vala"
	_tmp1_ = number_subtract (t1, margin);
#line 144 "../lib/financial.vala"
	t2 = _tmp1_;
#line 145 "../lib/financial.vala"
	_tmp2_ = number_divide (cost, t2);
#line 145 "../lib/financial.vala"
	result = _tmp2_;
#line 145 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 145 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 145 "../lib/financial.vala"
	return result;
#line 613 "financial.c"
}

Number*
calc_pmt (MathEquation* equation,
          Number* prin,
          Number* pint,
          Number* n)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* t2 = NULL;
	Number* _tmp4_;
	Number* t3 = NULL;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* t4 = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* result;
#line 148 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 148 "../lib/financial.vala"
	g_return_val_if_fail (prin != NULL, NULL);
#line 148 "../lib/financial.vala"
	g_return_val_if_fail (pint != NULL, NULL);
#line 148 "../lib/financial.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 157 "../lib/financial.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 157 "../lib/financial.vala"
	_tmp1_ = _tmp0_;
#line 157 "../lib/financial.vala"
	_tmp2_ = number_add (pint, _tmp1_);
#line 157 "../lib/financial.vala"
	_tmp3_ = _tmp2_;
#line 157 "../lib/financial.vala"
	_g_object_unref0 (_tmp1_);
#line 157 "../lib/financial.vala"
	t1 = _tmp3_;
#line 158 "../lib/financial.vala"
	_tmp4_ = number_multiply_integer (n, (gint64) -1);
#line 158 "../lib/financial.vala"
	t2 = _tmp4_;
#line 159 "../lib/financial.vala"
	_tmp5_ = t1;
#line 159 "../lib/financial.vala"
	_tmp6_ = t2;
#line 159 "../lib/financial.vala"
	_tmp7_ = number_xpowy (_tmp5_, _tmp6_);
#line 159 "../lib/financial.vala"
	t3 = _tmp7_;
#line 160 "../lib/financial.vala"
	_tmp8_ = number_multiply_integer (t3, (gint64) -1);
#line 160 "../lib/financial.vala"
	t4 = _tmp8_;
#line 161 "../lib/financial.vala"
	_tmp9_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 161 "../lib/financial.vala"
	_tmp10_ = _tmp9_;
#line 161 "../lib/financial.vala"
	_tmp11_ = number_add (t4, _tmp10_);
#line 161 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 161 "../lib/financial.vala"
	t1 = _tmp11_;
#line 161 "../lib/financial.vala"
	_g_object_unref0 (_tmp10_);
#line 162 "../lib/financial.vala"
	_tmp12_ = t1;
#line 162 "../lib/financial.vala"
	_tmp13_ = number_divide (pint, _tmp12_);
#line 162 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 162 "../lib/financial.vala"
	t2 = _tmp13_;
#line 163 "../lib/financial.vala"
	_tmp14_ = t2;
#line 163 "../lib/financial.vala"
	_tmp15_ = number_multiply (prin, _tmp14_);
#line 163 "../lib/financial.vala"
	result = _tmp15_;
#line 163 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 163 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 163 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 163 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 163 "../lib/financial.vala"
	return result;
#line 715 "financial.c"
}

Number*
calc_pv (MathEquation* equation,
         Number* pmt,
         Number* pint,
         Number* n)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* t2 = NULL;
	Number* _tmp4_;
	Number* t3 = NULL;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* t4 = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* result;
#line 166 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 166 "../lib/financial.vala"
	g_return_val_if_fail (pmt != NULL, NULL);
#line 166 "../lib/financial.vala"
	g_return_val_if_fail (pint != NULL, NULL);
#line 166 "../lib/financial.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 175 "../lib/financial.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 175 "../lib/financial.vala"
	_tmp1_ = _tmp0_;
#line 175 "../lib/financial.vala"
	_tmp2_ = number_add (pint, _tmp1_);
#line 175 "../lib/financial.vala"
	_tmp3_ = _tmp2_;
#line 175 "../lib/financial.vala"
	_g_object_unref0 (_tmp1_);
#line 175 "../lib/financial.vala"
	t1 = _tmp3_;
#line 176 "../lib/financial.vala"
	_tmp4_ = number_multiply_integer (n, (gint64) -1);
#line 176 "../lib/financial.vala"
	t2 = _tmp4_;
#line 177 "../lib/financial.vala"
	_tmp5_ = t1;
#line 177 "../lib/financial.vala"
	_tmp6_ = t2;
#line 177 "../lib/financial.vala"
	_tmp7_ = number_xpowy (_tmp5_, _tmp6_);
#line 177 "../lib/financial.vala"
	t3 = _tmp7_;
#line 178 "../lib/financial.vala"
	_tmp8_ = number_multiply_integer (t3, (gint64) -1);
#line 178 "../lib/financial.vala"
	t4 = _tmp8_;
#line 179 "../lib/financial.vala"
	_tmp9_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 179 "../lib/financial.vala"
	_tmp10_ = _tmp9_;
#line 179 "../lib/financial.vala"
	_tmp11_ = number_add (t4, _tmp10_);
#line 179 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 179 "../lib/financial.vala"
	t1 = _tmp11_;
#line 179 "../lib/financial.vala"
	_g_object_unref0 (_tmp10_);
#line 180 "../lib/financial.vala"
	_tmp12_ = t1;
#line 180 "../lib/financial.vala"
	_tmp13_ = number_divide (_tmp12_, pint);
#line 180 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 180 "../lib/financial.vala"
	t2 = _tmp13_;
#line 181 "../lib/financial.vala"
	_tmp14_ = t2;
#line 181 "../lib/financial.vala"
	_tmp15_ = number_multiply (pmt, _tmp14_);
#line 181 "../lib/financial.vala"
	result = _tmp15_;
#line 181 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 181 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 181 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 181 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 181 "../lib/financial.vala"
	return result;
#line 817 "financial.c"
}

Number*
calc_rate (MathEquation* equation,
           Number* fv,
           Number* pv,
           Number* n)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* t2 = NULL;
	Number* _tmp1_;
	Number* t3 = NULL;
	Number* _tmp2_;
	Number* t4 = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* result;
#line 184 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 184 "../lib/financial.vala"
	g_return_val_if_fail (fv != NULL, NULL);
#line 184 "../lib/financial.vala"
	g_return_val_if_fail (pv != NULL, NULL);
#line 184 "../lib/financial.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 193 "../lib/financial.vala"
	_tmp0_ = number_divide (fv, pv);
#line 193 "../lib/financial.vala"
	t1 = _tmp0_;
#line 194 "../lib/financial.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 194 "../lib/financial.vala"
	t2 = _tmp1_;
#line 195 "../lib/financial.vala"
	_tmp2_ = number_divide (t2, n);
#line 195 "../lib/financial.vala"
	t3 = _tmp2_;
#line 196 "../lib/financial.vala"
	_tmp3_ = number_xpowy (t1, t3);
#line 196 "../lib/financial.vala"
	t4 = _tmp3_;
#line 197 "../lib/financial.vala"
	_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 197 "../lib/financial.vala"
	_tmp5_ = _tmp4_;
#line 197 "../lib/financial.vala"
	_tmp6_ = number_add (t4, _tmp5_);
#line 197 "../lib/financial.vala"
	_tmp7_ = _tmp6_;
#line 197 "../lib/financial.vala"
	_g_object_unref0 (_tmp5_);
#line 197 "../lib/financial.vala"
	result = _tmp7_;
#line 197 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 197 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 197 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 197 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 197 "../lib/financial.vala"
	return result;
#line 885 "financial.c"
}

Number*
calc_sln (MathEquation* equation,
          Number* cost,
          Number* salvage,
          Number* life)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* result;
#line 200 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 200 "../lib/financial.vala"
	g_return_val_if_fail (cost != NULL, NULL);
#line 200 "../lib/financial.vala"
	g_return_val_if_fail (salvage != NULL, NULL);
#line 200 "../lib/financial.vala"
	g_return_val_if_fail (life != NULL, NULL);
#line 209 "../lib/financial.vala"
	_tmp0_ = number_subtract (cost, salvage);
#line 209 "../lib/financial.vala"
	t1 = _tmp0_;
#line 210 "../lib/financial.vala"
	_tmp1_ = number_divide (t1, life);
#line 210 "../lib/financial.vala"
	result = _tmp1_;
#line 210 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 210 "../lib/financial.vala"
	return result;
#line 918 "financial.c"
}

Number*
calc_syd (MathEquation* equation,
          Number* cost,
          Number* salvage,
          Number* life,
          Number* period)
{
	Number* t3 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t2 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* t4 = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* t1 = NULL;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* _tmp19_;
	Number* _tmp20_;
	Number* _tmp21_;
	Number* result;
#line 213 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 213 "../lib/financial.vala"
	g_return_val_if_fail (cost != NULL, NULL);
#line 213 "../lib/financial.vala"
	g_return_val_if_fail (salvage != NULL, NULL);
#line 213 "../lib/financial.vala"
	g_return_val_if_fail (life != NULL, NULL);
#line 213 "../lib/financial.vala"
	g_return_val_if_fail (period != NULL, NULL);
#line 224 "../lib/financial.vala"
	_tmp0_ = number_subtract (life, period);
#line 224 "../lib/financial.vala"
	_tmp1_ = _tmp0_;
#line 224 "../lib/financial.vala"
	_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 224 "../lib/financial.vala"
	_tmp3_ = _tmp2_;
#line 224 "../lib/financial.vala"
	_tmp4_ = number_add (_tmp1_, _tmp3_);
#line 224 "../lib/financial.vala"
	_tmp5_ = _tmp4_;
#line 224 "../lib/financial.vala"
	_g_object_unref0 (_tmp3_);
#line 224 "../lib/financial.vala"
	_g_object_unref0 (_tmp1_);
#line 224 "../lib/financial.vala"
	t3 = _tmp5_;
#line 225 "../lib/financial.vala"
	_tmp6_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 225 "../lib/financial.vala"
	_tmp7_ = _tmp6_;
#line 225 "../lib/financial.vala"
	_tmp8_ = number_add (life, _tmp7_);
#line 225 "../lib/financial.vala"
	_tmp9_ = _tmp8_;
#line 225 "../lib/financial.vala"
	_g_object_unref0 (_tmp7_);
#line 225 "../lib/financial.vala"
	t2 = _tmp9_;
#line 226 "../lib/financial.vala"
	_tmp10_ = t2;
#line 226 "../lib/financial.vala"
	_tmp11_ = number_multiply (life, _tmp10_);
#line 226 "../lib/financial.vala"
	t4 = _tmp11_;
#line 227 "../lib/financial.vala"
	_tmp12_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 227 "../lib/financial.vala"
	_tmp13_ = _tmp12_;
#line 227 "../lib/financial.vala"
	_tmp14_ = number_divide (t4, _tmp13_);
#line 227 "../lib/financial.vala"
	_tmp15_ = _tmp14_;
#line 227 "../lib/financial.vala"
	_g_object_unref0 (_tmp13_);
#line 227 "../lib/financial.vala"
	t1 = _tmp15_;
#line 228 "../lib/financial.vala"
	_tmp16_ = t1;
#line 228 "../lib/financial.vala"
	_tmp17_ = number_divide (t3, _tmp16_);
#line 228 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 228 "../lib/financial.vala"
	t2 = _tmp17_;
#line 229 "../lib/financial.vala"
	_tmp18_ = number_subtract (cost, salvage);
#line 229 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 229 "../lib/financial.vala"
	t1 = _tmp18_;
#line 230 "../lib/financial.vala"
	_tmp19_ = t1;
#line 230 "../lib/financial.vala"
	_tmp20_ = t2;
#line 230 "../lib/financial.vala"
	_tmp21_ = number_multiply (_tmp19_, _tmp20_);
#line 230 "../lib/financial.vala"
	result = _tmp21_;
#line 230 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 230 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 230 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 230 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 230 "../lib/financial.vala"
	return result;
#line 1045 "financial.c"
}

Number*
calc_term (MathEquation* equation,
           Number* pmt,
           Number* fv,
           Number* pint)
{
	Number* t1 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* t2 = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* t3 = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* t4 = NULL;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* result;
#line 233 "../lib/financial.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 233 "../lib/financial.vala"
	g_return_val_if_fail (pmt != NULL, NULL);
#line 233 "../lib/financial.vala"
	g_return_val_if_fail (fv != NULL, NULL);
#line 233 "../lib/financial.vala"
	g_return_val_if_fail (pint != NULL, NULL);
#line 242 "../lib/financial.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 242 "../lib/financial.vala"
	_tmp1_ = _tmp0_;
#line 242 "../lib/financial.vala"
	_tmp2_ = number_add (pint, _tmp1_);
#line 242 "../lib/financial.vala"
	_tmp3_ = _tmp2_;
#line 242 "../lib/financial.vala"
	_g_object_unref0 (_tmp1_);
#line 242 "../lib/financial.vala"
	t1 = _tmp3_;
#line 243 "../lib/financial.vala"
	_tmp4_ = t1;
#line 243 "../lib/financial.vala"
	_tmp5_ = number_ln (_tmp4_);
#line 243 "../lib/financial.vala"
	t2 = _tmp5_;
#line 244 "../lib/financial.vala"
	_tmp6_ = number_multiply (fv, pint);
#line 244 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 244 "../lib/financial.vala"
	t1 = _tmp6_;
#line 245 "../lib/financial.vala"
	_tmp7_ = t1;
#line 245 "../lib/financial.vala"
	_tmp8_ = number_divide (_tmp7_, pmt);
#line 245 "../lib/financial.vala"
	t3 = _tmp8_;
#line 246 "../lib/financial.vala"
	_tmp9_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 246 "../lib/financial.vala"
	_tmp10_ = _tmp9_;
#line 246 "../lib/financial.vala"
	_tmp11_ = number_add (t3, _tmp10_);
#line 246 "../lib/financial.vala"
	_tmp12_ = _tmp11_;
#line 246 "../lib/financial.vala"
	_g_object_unref0 (_tmp10_);
#line 246 "../lib/financial.vala"
	t4 = _tmp12_;
#line 247 "../lib/financial.vala"
	_tmp13_ = number_ln (t4);
#line 247 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 247 "../lib/financial.vala"
	t1 = _tmp13_;
#line 248 "../lib/financial.vala"
	_tmp14_ = t1;
#line 248 "../lib/financial.vala"
	_tmp15_ = number_divide (_tmp14_, t2);
#line 248 "../lib/financial.vala"
	result = _tmp15_;
#line 248 "../lib/financial.vala"
	_g_object_unref0 (t4);
#line 248 "../lib/financial.vala"
	_g_object_unref0 (t3);
#line 248 "../lib/financial.vala"
	_g_object_unref0 (t2);
#line 248 "../lib/financial.vala"
	_g_object_unref0 (t1);
#line 248 "../lib/financial.vala"
	return result;
#line 1147 "financial.c"
}

