/* function-manager.c generated by valac 0.56.15, the Vala compiler
 * generated from function-manager.vala, do not modify */

/*
 * Copyright (C) 2013 Garima Joshi
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "calculator.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FUNCTION_MANAGER_0_PROPERTY,
	FUNCTION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* function_manager_properties[FUNCTION_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	FUNCTION_MANAGER_FUNCTION_ADDED_SIGNAL,
	FUNCTION_MANAGER_FUNCTION_EDITED_SIGNAL,
	FUNCTION_MANAGER_FUNCTION_DELETED_SIGNAL,
	FUNCTION_MANAGER_NUM_SIGNALS
};
static guint function_manager_signals[FUNCTION_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FunctionManagerPrivate {
	gchar* file_name;
	GHashTable* functions;
	Serializer* serializer;
};

VALA_EXTERN FunctionManager* default_function_manager;
FunctionManager* default_function_manager = NULL;
static gint FunctionManager_private_offset;
static gpointer function_manager_parent_class = NULL;

static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void function_manager_reload_functions (FunctionManager* self);
static void function_manager_reload_custom_functions (FunctionManager* self);
static void function_manager_reload_builtin_functions (FunctionManager* self);
static gboolean function_manager_add (FunctionManager* self,
                               MathFunction* new_function);
static MathFunction* function_manager_parse_function_from_string (FunctionManager* self,
                                                           const gchar* data);
static void function_manager_save (FunctionManager* self);
static gchar** function_manager_array_sort_string (FunctionManager* self,
                                            gchar** array,
                                            gint array_length1,
                                            gint* result_length1);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static Number** _vala_array_dup2 (Number** self,
                           gssize length);
static void _vala_array_add4 (Number** * array,
                       gint* length,
                       gint* size,
                       Number* value);
static MathFunction** function_manager_array_sort_math_function (FunctionManager* self,
                                                          MathFunction** array,
                                                          gint array_length1,
                                                          gint* result_length1);
static MathFunction** _vala_array_dup3 (MathFunction** self,
                                 gssize length);
static MathFunction** _vala_array_dup4 (MathFunction** self,
                                 gssize length);
static void _vala_array_add5 (MathFunction** * array,
                       gint* length,
                       gint* size,
                       MathFunction* value);
static void function_manager_finalize (GObject * obj);
static GType function_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
function_manager_get_instance_private (FunctionManager* self)
{
	return G_STRUCT_MEMBER_P (self, FunctionManager_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 25 "../lib/function-manager.vala"
	var = (g_free (var), NULL);
#line 119 "function-manager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 25 "../lib/function-manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 127 "function-manager.c"
}

FunctionManager*
function_manager_construct (GType object_type)
{
	FunctionManager * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	Serializer* _tmp5_;
	Serializer* _tmp6_;
#line 23 "../lib/function-manager.vala"
	self = (FunctionManager*) g_object_new (object_type, NULL);
#line 25 "../lib/function-manager.vala"
	_tmp0_ = g_str_hash;
#line 25 "../lib/function-manager.vala"
	_tmp1_ = g_str_equal;
#line 25 "../lib/function-manager.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 25 "../lib/function-manager.vala"
	_g_hash_table_unref0 (self->priv->functions);
#line 25 "../lib/function-manager.vala"
	self->priv->functions = _tmp2_;
#line 26 "../lib/function-manager.vala"
	_tmp3_ = g_get_user_data_dir ();
#line 26 "../lib/function-manager.vala"
	_tmp4_ = g_build_filename (_tmp3_, "gnome-calculator", "custom-functions", NULL);
#line 26 "../lib/function-manager.vala"
	_g_free0 (self->priv->file_name);
#line 26 "../lib/function-manager.vala"
	self->priv->file_name = _tmp4_;
#line 27 "../lib/function-manager.vala"
	_tmp5_ = serializer_new (DISPLAY_FORMAT_SCIENTIFIC, 10, 50);
#line 27 "../lib/function-manager.vala"
	_g_object_unref0 (self->priv->serializer);
#line 27 "../lib/function-manager.vala"
	self->priv->serializer = _tmp5_;
#line 28 "../lib/function-manager.vala"
	_tmp6_ = self->priv->serializer;
#line 28 "../lib/function-manager.vala"
	serializer_set_radix (_tmp6_, (gunichar) '.');
#line 29 "../lib/function-manager.vala"
	function_manager_reload_functions (self);
#line 23 "../lib/function-manager.vala"
	return self;
#line 175 "function-manager.c"
}

FunctionManager*
function_manager_new (void)
{
#line 23 "../lib/function-manager.vala"
	return function_manager_construct (TYPE_FUNCTION_MANAGER);
#line 183 "function-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../lib/function-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 191 "function-manager.c"
}

FunctionManager*
function_manager_get_default_function_manager (void)
{
	FunctionManager* _tmp0_;
	FunctionManager* _tmp2_;
	FunctionManager* _tmp3_;
	FunctionManager* result;
#line 34 "../lib/function-manager.vala"
	_tmp0_ = default_function_manager;
#line 34 "../lib/function-manager.vala"
	if (_tmp0_ == NULL) {
#line 205 "function-manager.c"
		FunctionManager* _tmp1_;
#line 35 "../lib/function-manager.vala"
		_tmp1_ = function_manager_new ();
#line 35 "../lib/function-manager.vala"
		_g_object_unref0 (default_function_manager);
#line 35 "../lib/function-manager.vala"
		default_function_manager = _tmp1_;
#line 213 "function-manager.c"
	}
#line 36 "../lib/function-manager.vala"
	_tmp2_ = default_function_manager;
#line 36 "../lib/function-manager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 36 "../lib/function-manager.vala"
	result = _tmp3_;
#line 36 "../lib/function-manager.vala"
	return result;
#line 223 "function-manager.c"
}

static void
function_manager_reload_functions (FunctionManager* self)
{
	GHashTable* _tmp0_;
#line 39 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/function-manager.vala"
	_tmp0_ = self->priv->functions;
#line 41 "../lib/function-manager.vala"
	g_hash_table_remove_all (_tmp0_);
#line 42 "../lib/function-manager.vala"
	function_manager_reload_custom_functions (self);
#line 43 "../lib/function-manager.vala"
	function_manager_reload_builtin_functions (self);
#line 240 "function-manager.c"
}

static void
function_manager_reload_builtin_functions (FunctionManager* self)
{
	BuiltInMathFunction* _tmp0_;
	BuiltInMathFunction* _tmp1_;
	BuiltInMathFunction* _tmp2_;
	BuiltInMathFunction* _tmp3_;
	BuiltInMathFunction* _tmp4_;
	BuiltInMathFunction* _tmp5_;
	BuiltInMathFunction* _tmp6_;
	BuiltInMathFunction* _tmp7_;
	BuiltInMathFunction* _tmp8_;
	BuiltInMathFunction* _tmp9_;
	BuiltInMathFunction* _tmp10_;
	BuiltInMathFunction* _tmp11_;
	BuiltInMathFunction* _tmp12_;
	BuiltInMathFunction* _tmp13_;
	BuiltInMathFunction* _tmp14_;
	BuiltInMathFunction* _tmp15_;
	BuiltInMathFunction* _tmp16_;
	BuiltInMathFunction* _tmp17_;
	BuiltInMathFunction* _tmp18_;
	BuiltInMathFunction* _tmp19_;
	BuiltInMathFunction* _tmp20_;
	BuiltInMathFunction* _tmp21_;
	BuiltInMathFunction* _tmp22_;
	BuiltInMathFunction* _tmp23_;
	BuiltInMathFunction* _tmp24_;
	BuiltInMathFunction* _tmp25_;
	BuiltInMathFunction* _tmp26_;
	BuiltInMathFunction* _tmp27_;
	BuiltInMathFunction* _tmp28_;
	BuiltInMathFunction* _tmp29_;
	BuiltInMathFunction* _tmp30_;
	BuiltInMathFunction* _tmp31_;
	BuiltInMathFunction* _tmp32_;
	BuiltInMathFunction* _tmp33_;
	BuiltInMathFunction* _tmp34_;
	BuiltInMathFunction* _tmp35_;
	BuiltInMathFunction* _tmp36_;
	BuiltInMathFunction* _tmp37_;
	BuiltInMathFunction* _tmp38_;
	BuiltInMathFunction* _tmp39_;
	BuiltInMathFunction* _tmp40_;
	BuiltInMathFunction* _tmp41_;
	BuiltInMathFunction* _tmp42_;
	BuiltInMathFunction* _tmp43_;
	BuiltInMathFunction* _tmp44_;
	BuiltInMathFunction* _tmp45_;
	BuiltInMathFunction* _tmp46_;
	BuiltInMathFunction* _tmp47_;
	BuiltInMathFunction* _tmp48_;
	BuiltInMathFunction* _tmp49_;
	BuiltInMathFunction* _tmp50_;
	BuiltInMathFunction* _tmp51_;
	BuiltInMathFunction* _tmp52_;
	BuiltInMathFunction* _tmp53_;
	BuiltInMathFunction* _tmp54_;
	BuiltInMathFunction* _tmp55_;
	BuiltInMathFunction* _tmp56_;
	BuiltInMathFunction* _tmp57_;
	BuiltInMathFunction* _tmp58_;
	BuiltInMathFunction* _tmp59_;
	BuiltInMathFunction* _tmp60_;
	BuiltInMathFunction* _tmp61_;
	BuiltInMathFunction* _tmp62_;
	BuiltInMathFunction* _tmp63_;
	BuiltInMathFunction* _tmp64_;
	BuiltInMathFunction* _tmp65_;
	BuiltInMathFunction* _tmp66_;
	BuiltInMathFunction* _tmp67_;
#line 46 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 48 "../lib/function-manager.vala"
	_tmp0_ = built_in_math_function_new ("log", _ ("Logarithm"));
#line 48 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 48 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp1_);
#line 48 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "../lib/function-manager.vala"
	_tmp2_ = built_in_math_function_new ("ln", _ ("Natural logarithm"));
#line 50 "../lib/function-manager.vala"
	_tmp3_ = _tmp2_;
#line 50 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp3_);
#line 50 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp3_);
#line 52 "../lib/function-manager.vala"
	_tmp4_ = built_in_math_function_new ("sqrt", _ ("Square root"));
#line 52 "../lib/function-manager.vala"
	_tmp5_ = _tmp4_;
#line 52 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp5_);
#line 52 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp5_);
#line 54 "../lib/function-manager.vala"
	_tmp6_ = built_in_math_function_new ("abs", _ ("Absolute value"));
#line 54 "../lib/function-manager.vala"
	_tmp7_ = _tmp6_;
#line 54 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp7_);
#line 54 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp7_);
#line 56 "../lib/function-manager.vala"
	_tmp8_ = built_in_math_function_new ("sgn", _ ("Signum"));
#line 56 "../lib/function-manager.vala"
	_tmp9_ = _tmp8_;
#line 56 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp9_);
#line 56 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp9_);
#line 58 "../lib/function-manager.vala"
	_tmp10_ = built_in_math_function_new ("arg", _ ("Argument"));
#line 58 "../lib/function-manager.vala"
	_tmp11_ = _tmp10_;
#line 58 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp11_);
#line 58 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp11_);
#line 60 "../lib/function-manager.vala"
	_tmp12_ = built_in_math_function_new ("conj", _ ("Conjugate"));
#line 60 "../lib/function-manager.vala"
	_tmp13_ = _tmp12_;
#line 60 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp13_);
#line 60 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp13_);
#line 62 "../lib/function-manager.vala"
	_tmp14_ = built_in_math_function_new ("int", _ ("Integer"));
#line 62 "../lib/function-manager.vala"
	_tmp15_ = _tmp14_;
#line 62 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp15_);
#line 62 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp15_);
#line 64 "../lib/function-manager.vala"
	_tmp16_ = built_in_math_function_new ("frac", _ ("Fraction"));
#line 64 "../lib/function-manager.vala"
	_tmp17_ = _tmp16_;
#line 64 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp17_);
#line 64 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp17_);
#line 66 "../lib/function-manager.vala"
	_tmp18_ = built_in_math_function_new ("floor", _ ("Floor"));
#line 66 "../lib/function-manager.vala"
	_tmp19_ = _tmp18_;
#line 66 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp19_);
#line 66 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp19_);
#line 68 "../lib/function-manager.vala"
	_tmp20_ = built_in_math_function_new ("ceil", _ ("Ceiling"));
#line 68 "../lib/function-manager.vala"
	_tmp21_ = _tmp20_;
#line 68 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp21_);
#line 68 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp21_);
#line 70 "../lib/function-manager.vala"
	_tmp22_ = built_in_math_function_new ("round", _ ("Round"));
#line 70 "../lib/function-manager.vala"
	_tmp23_ = _tmp22_;
#line 70 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp23_);
#line 70 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp23_);
#line 72 "../lib/function-manager.vala"
	_tmp24_ = built_in_math_function_new ("re", _ ("Real"));
#line 72 "../lib/function-manager.vala"
	_tmp25_ = _tmp24_;
#line 72 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp25_);
#line 72 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp25_);
#line 74 "../lib/function-manager.vala"
	_tmp26_ = built_in_math_function_new ("im", _ ("Imaginary"));
#line 74 "../lib/function-manager.vala"
	_tmp27_ = _tmp26_;
#line 74 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp27_);
#line 74 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp27_);
#line 76 "../lib/function-manager.vala"
	_tmp28_ = built_in_math_function_new ("sin", _ ("Sine"));
#line 76 "../lib/function-manager.vala"
	_tmp29_ = _tmp28_;
#line 76 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp29_);
#line 76 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp29_);
#line 78 "../lib/function-manager.vala"
	_tmp30_ = built_in_math_function_new ("cos", _ ("Cosine"));
#line 78 "../lib/function-manager.vala"
	_tmp31_ = _tmp30_;
#line 78 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp31_);
#line 78 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp31_);
#line 80 "../lib/function-manager.vala"
	_tmp32_ = built_in_math_function_new ("tan", _ ("Tangent"));
#line 80 "../lib/function-manager.vala"
	_tmp33_ = _tmp32_;
#line 80 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp33_);
#line 80 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp33_);
#line 82 "../lib/function-manager.vala"
	_tmp34_ = built_in_math_function_new ("asin", _ ("Arc sine"));
#line 82 "../lib/function-manager.vala"
	_tmp35_ = _tmp34_;
#line 82 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp35_);
#line 82 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp35_);
#line 84 "../lib/function-manager.vala"
	_tmp36_ = built_in_math_function_new ("acos", _ ("Arc cosine"));
#line 84 "../lib/function-manager.vala"
	_tmp37_ = _tmp36_;
#line 84 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp37_);
#line 84 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp37_);
#line 86 "../lib/function-manager.vala"
	_tmp38_ = built_in_math_function_new ("atan", _ ("Arc tangent"));
#line 86 "../lib/function-manager.vala"
	_tmp39_ = _tmp38_;
#line 86 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp39_);
#line 86 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp39_);
#line 88 "../lib/function-manager.vala"
	_tmp40_ = built_in_math_function_new ("sin⁻¹", _ ("Inverse sine"));
#line 88 "../lib/function-manager.vala"
	_tmp41_ = _tmp40_;
#line 88 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp41_);
#line 88 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp41_);
#line 90 "../lib/function-manager.vala"
	_tmp42_ = built_in_math_function_new ("cos⁻¹", _ ("Inverse cosine"));
#line 90 "../lib/function-manager.vala"
	_tmp43_ = _tmp42_;
#line 90 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp43_);
#line 90 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp43_);
#line 92 "../lib/function-manager.vala"
	_tmp44_ = built_in_math_function_new ("tan⁻¹", _ ("Inverse tangent"));
#line 92 "../lib/function-manager.vala"
	_tmp45_ = _tmp44_;
#line 92 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp45_);
#line 92 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp45_);
#line 94 "../lib/function-manager.vala"
	_tmp46_ = built_in_math_function_new ("sinh", _ ("Hyperbolic sine"));
#line 94 "../lib/function-manager.vala"
	_tmp47_ = _tmp46_;
#line 94 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp47_);
#line 94 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp47_);
#line 96 "../lib/function-manager.vala"
	_tmp48_ = built_in_math_function_new ("cosh", _ ("Hyperbolic cosine"));
#line 96 "../lib/function-manager.vala"
	_tmp49_ = _tmp48_;
#line 96 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp49_);
#line 96 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp49_);
#line 98 "../lib/function-manager.vala"
	_tmp50_ = built_in_math_function_new ("tanh", _ ("Hyperbolic tangent"));
#line 98 "../lib/function-manager.vala"
	_tmp51_ = _tmp50_;
#line 98 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp51_);
#line 98 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp51_);
#line 100 "../lib/function-manager.vala"
	_tmp52_ = built_in_math_function_new ("sinh⁻¹", _ ("Hyperbolic arcsine"));
#line 100 "../lib/function-manager.vala"
	_tmp53_ = _tmp52_;
#line 100 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp53_);
#line 100 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp53_);
#line 102 "../lib/function-manager.vala"
	_tmp54_ = built_in_math_function_new ("cosh⁻¹", _ ("Hyperbolic arccosine"));
#line 102 "../lib/function-manager.vala"
	_tmp55_ = _tmp54_;
#line 102 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp55_);
#line 102 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp55_);
#line 104 "../lib/function-manager.vala"
	_tmp56_ = built_in_math_function_new ("tanh⁻¹", _ ("Hyperbolic arctangent"));
#line 104 "../lib/function-manager.vala"
	_tmp57_ = _tmp56_;
#line 104 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp57_);
#line 104 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp57_);
#line 106 "../lib/function-manager.vala"
	_tmp58_ = built_in_math_function_new ("asinh", _ ("Inverse hyperbolic sine"));
#line 106 "../lib/function-manager.vala"
	_tmp59_ = _tmp58_;
#line 106 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp59_);
#line 106 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp59_);
#line 108 "../lib/function-manager.vala"
	_tmp60_ = built_in_math_function_new ("acosh", _ ("Inverse hyperbolic cosine"));
#line 108 "../lib/function-manager.vala"
	_tmp61_ = _tmp60_;
#line 108 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp61_);
#line 108 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp61_);
#line 110 "../lib/function-manager.vala"
	_tmp62_ = built_in_math_function_new ("atanh", _ ("Inverse hyperbolic tangent"));
#line 110 "../lib/function-manager.vala"
	_tmp63_ = _tmp62_;
#line 110 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp63_);
#line 110 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp63_);
#line 112 "../lib/function-manager.vala"
	_tmp64_ = built_in_math_function_new ("ones", _ ("One's complement"));
#line 112 "../lib/function-manager.vala"
	_tmp65_ = _tmp64_;
#line 112 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp65_);
#line 112 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp65_);
#line 114 "../lib/function-manager.vala"
	_tmp66_ = built_in_math_function_new ("twos", _ ("Two's complement"));
#line 114 "../lib/function-manager.vala"
	_tmp67_ = _tmp66_;
#line 114 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp67_);
#line 114 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp67_);
#line 588 "function-manager.c"
}

static void
function_manager_reload_custom_functions (FunctionManager* self)
{
	gchar* data = NULL;
	gchar** lines = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
#line 117 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 606 "function-manager.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
#line 122 "../lib/function-manager.vala"
		_tmp0_ = self->priv->file_name;
#line 122 "../lib/function-manager.vala"
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 122 "../lib/function-manager.vala"
		_g_free0 (data);
#line 122 "../lib/function-manager.vala"
		data = _tmp1_;
#line 122 "../lib/function-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../lib/function-manager.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 622 "function-manager.c"
				goto __catch0_g_file_error;
			}
#line 122 "../lib/function-manager.vala"
			_g_free0 (data);
#line 122 "../lib/function-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "../lib/function-manager.vala"
			g_clear_error (&_inner_error0_);
#line 122 "../lib/function-manager.vala"
			return;
#line 633 "function-manager.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 120 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 126 "../lib/function-manager.vala"
		_g_free0 (data);
#line 126 "../lib/function-manager.vala"
		return;
#line 645 "function-manager.c"
	}
	__finally0:
#line 120 "../lib/function-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../lib/function-manager.vala"
		_g_free0 (data);
#line 120 "../lib/function-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 120 "../lib/function-manager.vala"
		return;
#line 658 "function-manager.c"
	}
#line 128 "../lib/function-manager.vala"
	_tmp2_ = data;
#line 128 "../lib/function-manager.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 128 "../lib/function-manager.vala"
	lines = _tmp4_;
#line 128 "../lib/function-manager.vala"
	lines_length1 = _vala_array_length (_tmp3_);
#line 128 "../lib/function-manager.vala"
	_lines_size_ = lines_length1;
#line 130 "../lib/function-manager.vala"
	_tmp5_ = lines;
#line 130 "../lib/function-manager.vala"
	_tmp5__length1 = lines_length1;
#line 674 "function-manager.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 130 "../lib/function-manager.vala"
		line_collection = _tmp5_;
#line 130 "../lib/function-manager.vala"
		line_collection_length1 = _tmp5__length1;
#line 130 "../lib/function-manager.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 686 "function-manager.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 130 "../lib/function-manager.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 130 "../lib/function-manager.vala"
			line = _tmp6_;
#line 693 "function-manager.c"
			{
				MathFunction* function = NULL;
				const gchar* _tmp7_;
				MathFunction* _tmp8_;
				MathFunction* _tmp9_;
#line 132 "../lib/function-manager.vala"
				_tmp7_ = line;
#line 132 "../lib/function-manager.vala"
				_tmp8_ = function_manager_parse_function_from_string (self, _tmp7_);
#line 132 "../lib/function-manager.vala"
				function = _tmp8_;
#line 133 "../lib/function-manager.vala"
				_tmp9_ = function;
#line 133 "../lib/function-manager.vala"
				if (_tmp9_ != NULL) {
#line 709 "function-manager.c"
					GHashTable* _tmp10_;
					MathFunction* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					MathFunction* _tmp15_;
					MathFunction* _tmp16_;
#line 134 "../lib/function-manager.vala"
					_tmp10_ = self->priv->functions;
#line 134 "../lib/function-manager.vala"
					_tmp11_ = function;
#line 134 "../lib/function-manager.vala"
					_tmp12_ = math_function_get_name (_tmp11_);
#line 134 "../lib/function-manager.vala"
					_tmp13_ = _tmp12_;
#line 134 "../lib/function-manager.vala"
					_tmp14_ = g_strdup (_tmp13_);
#line 134 "../lib/function-manager.vala"
					_tmp15_ = function;
#line 134 "../lib/function-manager.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 134 "../lib/function-manager.vala"
					g_hash_table_insert (_tmp10_, _tmp14_, _tmp16_);
#line 733 "function-manager.c"
				}
#line 130 "../lib/function-manager.vala"
				_g_object_unref0 (function);
#line 130 "../lib/function-manager.vala"
				_g_free0 (line);
#line 739 "function-manager.c"
			}
		}
	}
#line 117 "../lib/function-manager.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 117 "../lib/function-manager.vala"
	_g_free0 (data);
#line 747 "function-manager.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 769 "function-manager.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 777 "function-manager.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 783 "function-manager.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 807 "function-manager.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 816 "function-manager.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 835 "function-manager.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 839 "function-manager.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 845 "function-manager.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 855 "function-manager.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 863 "function-manager.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 867 "function-manager.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 873 "function-manager.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 883 "function-manager.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 904 "function-manager.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 926 "function-manager.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 930 "function-manager.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 936 "function-manager.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 940 "function-manager.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 944 "function-manager.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 952 "function-manager.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 980 "function-manager.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 989 "function-manager.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1003 "function-manager.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 1012 "function-manager.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 1026 "function-manager.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1035 "function-manager.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 1044 "function-manager.c"
}

static MathFunction*
function_manager_parse_function_from_string (FunctionManager* self,
                                             const gchar* data)
{
	gint i = 0;
	gchar* left = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* right = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* expression = NULL;
	gchar* _tmp11_;
	gchar* description = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* name = NULL;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* argument_list = NULL;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gboolean _tmp36_ = FALSE;
	const gchar* _tmp37_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	gchar** arguments = NULL;
	const gchar* _tmp41_;
	gchar** _tmp42_;
	gchar** _tmp43_;
	gint arguments_length1;
	gint _arguments_size_;
	const gchar* _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	MathFunction* _tmp48_;
	MathFunction* result;
#line 138 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../lib/function-manager.vala"
	if (data == NULL) {
#line 143 "../lib/function-manager.vala"
		result = NULL;
#line 143 "../lib/function-manager.vala"
		return result;
#line 1108 "function-manager.c"
	}
#line 145 "../lib/function-manager.vala"
	i = string_index_of_char (data, (gunichar) '=', 0);
#line 146 "../lib/function-manager.vala"
	if (i < 0) {
#line 147 "../lib/function-manager.vala"
		result = NULL;
#line 147 "../lib/function-manager.vala"
		return result;
#line 1118 "function-manager.c"
	}
#line 148 "../lib/function-manager.vala"
	_tmp0_ = string_substring (data, (glong) 0, (glong) i);
#line 148 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 148 "../lib/function-manager.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 148 "../lib/function-manager.vala"
	_tmp3_ = _tmp2_;
#line 148 "../lib/function-manager.vala"
	_g_free0 (_tmp1_);
#line 148 "../lib/function-manager.vala"
	left = _tmp3_;
#line 149 "../lib/function-manager.vala"
	_tmp4_ = string_substring (data, (glong) (i + 1), (glong) -1);
#line 149 "../lib/function-manager.vala"
	_tmp5_ = _tmp4_;
#line 149 "../lib/function-manager.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 149 "../lib/function-manager.vala"
	_tmp7_ = _tmp6_;
#line 149 "../lib/function-manager.vala"
	_g_free0 (_tmp5_);
#line 149 "../lib/function-manager.vala"
	right = _tmp7_;
#line 150 "../lib/function-manager.vala"
	_tmp9_ = left;
#line 150 "../lib/function-manager.vala"
	if (_tmp9_ == NULL) {
#line 150 "../lib/function-manager.vala"
		_tmp8_ = TRUE;
#line 1150 "function-manager.c"
	} else {
		const gchar* _tmp10_;
#line 150 "../lib/function-manager.vala"
		_tmp10_ = right;
#line 150 "../lib/function-manager.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 1157 "function-manager.c"
	}
#line 150 "../lib/function-manager.vala"
	if (_tmp8_) {
#line 151 "../lib/function-manager.vala"
		result = NULL;
#line 151 "../lib/function-manager.vala"
		_g_free0 (right);
#line 151 "../lib/function-manager.vala"
		_g_free0 (left);
#line 151 "../lib/function-manager.vala"
		return result;
#line 1169 "function-manager.c"
	}
#line 153 "../lib/function-manager.vala"
	_tmp11_ = g_strdup ("");
#line 153 "../lib/function-manager.vala"
	expression = _tmp11_;
#line 154 "../lib/function-manager.vala"
	_tmp12_ = g_strdup ("");
#line 154 "../lib/function-manager.vala"
	description = _tmp12_;
#line 155 "../lib/function-manager.vala"
	_tmp13_ = right;
#line 155 "../lib/function-manager.vala"
	i = string_index_of_char (_tmp13_, (gunichar) '@', 0);
#line 156 "../lib/function-manager.vala"
	if (i < 0) {
#line 1185 "function-manager.c"
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 157 "../lib/function-manager.vala"
		_tmp14_ = right;
#line 157 "../lib/function-manager.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 157 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 157 "../lib/function-manager.vala"
		expression = _tmp15_;
#line 1196 "function-manager.c"
	} else {
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 160 "../lib/function-manager.vala"
		_tmp16_ = right;
#line 160 "../lib/function-manager.vala"
		_tmp17_ = string_substring (_tmp16_, (glong) 0, (glong) i);
#line 160 "../lib/function-manager.vala"
		_tmp18_ = _tmp17_;
#line 160 "../lib/function-manager.vala"
		_tmp19_ = string_strip (_tmp18_);
#line 160 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 160 "../lib/function-manager.vala"
		expression = _tmp19_;
#line 160 "../lib/function-manager.vala"
		_g_free0 (_tmp18_);
#line 161 "../lib/function-manager.vala"
		_tmp20_ = right;
#line 161 "../lib/function-manager.vala"
		_tmp21_ = string_substring (_tmp20_, (glong) (i + 1), (glong) -1);
#line 161 "../lib/function-manager.vala"
		_tmp22_ = _tmp21_;
#line 161 "../lib/function-manager.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 161 "../lib/function-manager.vala"
		_g_free0 (description);
#line 161 "../lib/function-manager.vala"
		description = _tmp23_;
#line 161 "../lib/function-manager.vala"
		_g_free0 (_tmp22_);
#line 1234 "function-manager.c"
	}
#line 163 "../lib/function-manager.vala"
	_tmp24_ = expression;
#line 163 "../lib/function-manager.vala"
	if (_tmp24_ == NULL) {
#line 164 "../lib/function-manager.vala"
		result = NULL;
#line 164 "../lib/function-manager.vala"
		_g_free0 (description);
#line 164 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 164 "../lib/function-manager.vala"
		_g_free0 (right);
#line 164 "../lib/function-manager.vala"
		_g_free0 (left);
#line 164 "../lib/function-manager.vala"
		return result;
#line 1252 "function-manager.c"
	}
#line 166 "../lib/function-manager.vala"
	_tmp25_ = left;
#line 166 "../lib/function-manager.vala"
	i = string_index_of_char (_tmp25_, (gunichar) '(', 0);
#line 167 "../lib/function-manager.vala"
	if (i < 0) {
#line 168 "../lib/function-manager.vala"
		result = NULL;
#line 168 "../lib/function-manager.vala"
		_g_free0 (description);
#line 168 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 168 "../lib/function-manager.vala"
		_g_free0 (right);
#line 168 "../lib/function-manager.vala"
		_g_free0 (left);
#line 168 "../lib/function-manager.vala"
		return result;
#line 1272 "function-manager.c"
	}
#line 169 "../lib/function-manager.vala"
	_tmp26_ = left;
#line 169 "../lib/function-manager.vala"
	_tmp27_ = string_substring (_tmp26_, (glong) 0, (glong) i);
#line 169 "../lib/function-manager.vala"
	_tmp28_ = _tmp27_;
#line 169 "../lib/function-manager.vala"
	_tmp29_ = string_strip (_tmp28_);
#line 169 "../lib/function-manager.vala"
	_tmp30_ = _tmp29_;
#line 169 "../lib/function-manager.vala"
	_g_free0 (_tmp28_);
#line 169 "../lib/function-manager.vala"
	name = _tmp30_;
#line 170 "../lib/function-manager.vala"
	_tmp31_ = left;
#line 170 "../lib/function-manager.vala"
	_tmp32_ = string_substring (_tmp31_, (glong) (i + 1), (glong) -1);
#line 170 "../lib/function-manager.vala"
	_tmp33_ = _tmp32_;
#line 170 "../lib/function-manager.vala"
	_tmp34_ = string_strip (_tmp33_);
#line 170 "../lib/function-manager.vala"
	_tmp35_ = _tmp34_;
#line 170 "../lib/function-manager.vala"
	_g_free0 (_tmp33_);
#line 170 "../lib/function-manager.vala"
	argument_list = _tmp35_;
#line 171 "../lib/function-manager.vala"
	_tmp37_ = name;
#line 171 "../lib/function-manager.vala"
	if (_tmp37_ == NULL) {
#line 171 "../lib/function-manager.vala"
		_tmp36_ = TRUE;
#line 1308 "function-manager.c"
	} else {
		const gchar* _tmp38_;
#line 171 "../lib/function-manager.vala"
		_tmp38_ = argument_list;
#line 171 "../lib/function-manager.vala"
		_tmp36_ = _tmp38_ == NULL;
#line 1315 "function-manager.c"
	}
#line 171 "../lib/function-manager.vala"
	if (_tmp36_) {
#line 172 "../lib/function-manager.vala"
		result = NULL;
#line 172 "../lib/function-manager.vala"
		_g_free0 (argument_list);
#line 172 "../lib/function-manager.vala"
		_g_free0 (name);
#line 172 "../lib/function-manager.vala"
		_g_free0 (description);
#line 172 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 172 "../lib/function-manager.vala"
		_g_free0 (right);
#line 172 "../lib/function-manager.vala"
		_g_free0 (left);
#line 172 "../lib/function-manager.vala"
		return result;
#line 1335 "function-manager.c"
	}
#line 174 "../lib/function-manager.vala"
	_tmp39_ = argument_list;
#line 174 "../lib/function-manager.vala"
	_tmp40_ = string_replace (_tmp39_, ")", "");
#line 174 "../lib/function-manager.vala"
	_g_free0 (argument_list);
#line 174 "../lib/function-manager.vala"
	argument_list = _tmp40_;
#line 175 "../lib/function-manager.vala"
	_tmp41_ = argument_list;
#line 175 "../lib/function-manager.vala"
	_tmp43_ = _tmp42_ = g_strsplit_set (_tmp41_, ";", 0);
#line 175 "../lib/function-manager.vala"
	arguments = _tmp43_;
#line 175 "../lib/function-manager.vala"
	arguments_length1 = _vala_array_length (_tmp42_);
#line 175 "../lib/function-manager.vala"
	_arguments_size_ = arguments_length1;
#line 177 "../lib/function-manager.vala"
	_tmp44_ = name;
#line 177 "../lib/function-manager.vala"
	_tmp45_ = arguments;
#line 177 "../lib/function-manager.vala"
	_tmp45__length1 = arguments_length1;
#line 177 "../lib/function-manager.vala"
	_tmp46_ = expression;
#line 177 "../lib/function-manager.vala"
	_tmp47_ = description;
#line 177 "../lib/function-manager.vala"
	_tmp48_ = math_function_new (_tmp44_, _tmp45_, _tmp45__length1, _tmp46_, _tmp47_);
#line 177 "../lib/function-manager.vala"
	result = _tmp48_;
#line 177 "../lib/function-manager.vala"
	arguments = (_vala_array_free (arguments, arguments_length1, (GDestroyNotify) g_free), NULL);
#line 177 "../lib/function-manager.vala"
	_g_free0 (argument_list);
#line 177 "../lib/function-manager.vala"
	_g_free0 (name);
#line 177 "../lib/function-manager.vala"
	_g_free0 (description);
#line 177 "../lib/function-manager.vala"
	_g_free0 (expression);
#line 177 "../lib/function-manager.vala"
	_g_free0 (right);
#line 177 "../lib/function-manager.vala"
	_g_free0 (left);
#line 177 "../lib/function-manager.vala"
	return result;
#line 1385 "function-manager.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 1399 "function-manager.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1403 "function-manager.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1409 "function-manager.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1414 "function-manager.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1420 "function-manager.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1424 "function-manager.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1428 "function-manager.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1432 "function-manager.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1436 "function-manager.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1440 "function-manager.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1455 "function-manager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 1464 "function-manager.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1471 "function-manager.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1477 "function-manager.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1485 "function-manager.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1489 "function-manager.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1495 "function-manager.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1500 "function-manager.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1506 "function-manager.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1510 "function-manager.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1514 "function-manager.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 1520 "function-manager.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1526 "function-manager.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1538 "function-manager.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1542 "function-manager.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1546 "function-manager.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 1551 "function-manager.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 1559 "function-manager.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1577 "function-manager.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1583 "function-manager.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1587 "function-manager.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1595 "function-manager.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1604 "function-manager.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1613 "function-manager.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1619 "function-manager.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1627 "function-manager.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1639 "function-manager.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1645 "function-manager.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1649 "function-manager.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1657 "function-manager.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1668 "function-manager.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1677 "function-manager.c"
	}
}

static void
function_manager_save (FunctionManager* self)
{
	gchar* data = NULL;
	gchar* _tmp0_;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar* name = NULL;
	MathFunction* math_function = NULL;
	gchar* dir = NULL;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 180 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 182 "../lib/function-manager.vala"
	_tmp0_ = g_strdup ("");
#line 182 "../lib/function-manager.vala"
	data = _tmp0_;
#line 183 "../lib/function-manager.vala"
	_tmp1_ = self->priv->functions;
#line 183 "../lib/function-manager.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 186 "../lib/function-manager.vala"
	while (TRUE) {
#line 1706 "function-manager.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		gchar* _tmp5_;
		MathFunction* _tmp6_;
		MathFunction* _tmp7_;
		const gchar* _tmp8_;
		MathFunction* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		MathFunction* _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		gint _tmp14_ = 0;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		gchar* _tmp17_;
		MathFunction* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		MathFunction* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 186 "../lib/function-manager.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 186 "../lib/function-manager.vala"
		_g_free0 (name);
#line 186 "../lib/function-manager.vala"
		_tmp5_ = g_strdup ((const gchar*) _tmp2_);
#line 186 "../lib/function-manager.vala"
		name = _tmp5_;
#line 186 "../lib/function-manager.vala"
		_g_object_unref0 (math_function);
#line 186 "../lib/function-manager.vala"
		_tmp6_ = _g_object_ref0 ((MathFunction*) _tmp3_);
#line 186 "../lib/function-manager.vala"
		math_function = _tmp6_;
#line 186 "../lib/function-manager.vala"
		if (!_tmp4_) {
#line 186 "../lib/function-manager.vala"
			break;
#line 1752 "function-manager.c"
		}
#line 188 "../lib/function-manager.vala"
		_tmp7_ = math_function;
#line 188 "../lib/function-manager.vala"
		if (!math_function_is_custom_function (_tmp7_)) {
#line 189 "../lib/function-manager.vala"
			continue;
#line 1760 "function-manager.c"
		}
#line 191 "../lib/function-manager.vala"
		_tmp8_ = data;
#line 191 "../lib/function-manager.vala"
		_tmp9_ = math_function;
#line 191 "../lib/function-manager.vala"
		_tmp10_ = math_function_get_name (_tmp9_);
#line 191 "../lib/function-manager.vala"
		_tmp11_ = _tmp10_;
#line 191 "../lib/function-manager.vala"
		_tmp12_ = math_function;
#line 191 "../lib/function-manager.vala"
		_tmp13_ = math_function_get_arguments (_tmp12_, &_tmp14_);
#line 191 "../lib/function-manager.vala"
		_tmp13__length1 = _tmp14_;
#line 191 "../lib/function-manager.vala"
		_tmp15_ = _tmp13_;
#line 191 "../lib/function-manager.vala"
		_tmp15__length1 = _tmp13__length1;
#line 191 "../lib/function-manager.vala"
		_tmp16_ = _vala_g_strjoinv (";", _tmp15_, (gint) _tmp15__length1);
#line 191 "../lib/function-manager.vala"
		_tmp17_ = _tmp16_;
#line 191 "../lib/function-manager.vala"
		_tmp18_ = math_function;
#line 191 "../lib/function-manager.vala"
		_tmp19_ = math_function_get_expression (_tmp18_);
#line 191 "../lib/function-manager.vala"
		_tmp20_ = _tmp19_;
#line 191 "../lib/function-manager.vala"
		_tmp21_ = math_function;
#line 191 "../lib/function-manager.vala"
		_tmp22_ = math_function_get_description (_tmp21_);
#line 191 "../lib/function-manager.vala"
		_tmp23_ = _tmp22_;
#line 191 "../lib/function-manager.vala"
		_tmp24_ = g_strdup_printf ("%s(%s)=%s@%s\n", _tmp11_, _tmp17_, _tmp20_, _tmp23_);
#line 191 "../lib/function-manager.vala"
		_tmp25_ = _tmp24_;
#line 191 "../lib/function-manager.vala"
		_tmp26_ = g_strconcat (_tmp8_, _tmp25_, NULL);
#line 191 "../lib/function-manager.vala"
		_g_free0 (data);
#line 191 "../lib/function-manager.vala"
		data = _tmp26_;
#line 191 "../lib/function-manager.vala"
		_g_free0 (_tmp25_);
#line 191 "../lib/function-manager.vala"
		_g_free0 (_tmp17_);
#line 1810 "function-manager.c"
	}
#line 197 "../lib/function-manager.vala"
	_tmp27_ = self->priv->file_name;
#line 197 "../lib/function-manager.vala"
	_tmp28_ = g_path_get_dirname (_tmp27_);
#line 197 "../lib/function-manager.vala"
	dir = _tmp28_;
#line 198 "../lib/function-manager.vala"
	g_mkdir_with_parents (dir, 0700);
#line 1820 "function-manager.c"
	{
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 201 "../lib/function-manager.vala"
		_tmp29_ = self->priv->file_name;
#line 201 "../lib/function-manager.vala"
		_tmp30_ = data;
#line 201 "../lib/function-manager.vala"
		g_file_set_contents (_tmp29_, _tmp30_, (gssize) -1, &_inner_error0_);
#line 201 "../lib/function-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../lib/function-manager.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1834 "function-manager.c"
				goto __catch0_g_file_error;
			}
#line 201 "../lib/function-manager.vala"
			_g_free0 (dir);
#line 201 "../lib/function-manager.vala"
			_g_object_unref0 (math_function);
#line 201 "../lib/function-manager.vala"
			_g_free0 (name);
#line 201 "../lib/function-manager.vala"
			_g_free0 (data);
#line 201 "../lib/function-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../lib/function-manager.vala"
			g_clear_error (&_inner_error0_);
#line 201 "../lib/function-manager.vala"
			return;
#line 1851 "function-manager.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 199 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 1859 "function-manager.c"
	}
	__finally0:
#line 199 "../lib/function-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../lib/function-manager.vala"
		_g_free0 (dir);
#line 199 "../lib/function-manager.vala"
		_g_object_unref0 (math_function);
#line 199 "../lib/function-manager.vala"
		_g_free0 (name);
#line 199 "../lib/function-manager.vala"
		_g_free0 (data);
#line 199 "../lib/function-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 199 "../lib/function-manager.vala"
		return;
#line 1878 "function-manager.c"
	}
#line 180 "../lib/function-manager.vala"
	_g_free0 (dir);
#line 180 "../lib/function-manager.vala"
	_g_object_unref0 (math_function);
#line 180 "../lib/function-manager.vala"
	_g_free0 (name);
#line 180 "../lib/function-manager.vala"
	_g_free0 (data);
#line 1888 "function-manager.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 229 "../lib/function-manager.vala"
	if (length >= 0) {
#line 1897 "function-manager.c"
		gchar** result;
		gssize i;
#line 229 "../lib/function-manager.vala"
		result = g_new0 (gchar*, length + 1);
#line 229 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 1904 "function-manager.c"
			gchar* _tmp0_;
#line 229 "../lib/function-manager.vala"
			_tmp0_ = g_strdup (self[i]);
#line 229 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 1910 "function-manager.c"
		}
#line 229 "../lib/function-manager.vala"
		return result;
#line 1914 "function-manager.c"
	}
#line 229 "../lib/function-manager.vala"
	return NULL;
#line 1918 "function-manager.c"
}

static gchar**
function_manager_array_sort_string (FunctionManager* self,
                                    gchar** array,
                                    gint array_length1,
                                    gint* result_length1)
{
	gboolean swapped = FALSE;
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	gint j = 0;
	gchar* tmp = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar** result;
#line 208 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../lib/function-manager.vala"
	swapped = TRUE;
#line 211 "../lib/function-manager.vala"
	_tmp1_ = array[array_length1 - 1];
#line 211 "../lib/function-manager.vala"
	if (_tmp1_ == NULL) {
#line 211 "../lib/function-manager.vala"
		_tmp0_ = 1;
#line 1947 "function-manager.c"
	} else {
#line 211 "../lib/function-manager.vala"
		_tmp0_ = 0;
#line 1951 "function-manager.c"
	}
#line 211 "../lib/function-manager.vala"
	j = _tmp0_;
#line 214 "../lib/function-manager.vala"
	while (TRUE) {
#line 1957 "function-manager.c"
		gint _tmp2_;
#line 214 "../lib/function-manager.vala"
		if (!swapped) {
#line 214 "../lib/function-manager.vala"
			break;
#line 1963 "function-manager.c"
		}
#line 216 "../lib/function-manager.vala"
		swapped = FALSE;
#line 217 "../lib/function-manager.vala"
		_tmp2_ = j;
#line 217 "../lib/function-manager.vala"
		j = _tmp2_ + 1;
#line 1971 "function-manager.c"
		{
			gint i = 0;
#line 218 "../lib/function-manager.vala"
			i = 0;
#line 1976 "function-manager.c"
			{
				gboolean _tmp3_ = FALSE;
#line 218 "../lib/function-manager.vala"
				_tmp3_ = TRUE;
#line 218 "../lib/function-manager.vala"
				while (TRUE) {
#line 1983 "function-manager.c"
					const gchar* _tmp5_;
					const gchar* _tmp6_;
#line 218 "../lib/function-manager.vala"
					if (!_tmp3_) {
#line 1988 "function-manager.c"
						gint _tmp4_;
#line 218 "../lib/function-manager.vala"
						_tmp4_ = i;
#line 218 "../lib/function-manager.vala"
						i = _tmp4_ + 1;
#line 1994 "function-manager.c"
					}
#line 218 "../lib/function-manager.vala"
					_tmp3_ = FALSE;
#line 218 "../lib/function-manager.vala"
					if (!(i < (array_length1 - j))) {
#line 218 "../lib/function-manager.vala"
						break;
#line 2002 "function-manager.c"
					}
#line 220 "../lib/function-manager.vala"
					_tmp5_ = array[i];
#line 220 "../lib/function-manager.vala"
					_tmp6_ = array[i + 1];
#line 220 "../lib/function-manager.vala"
					if (g_strcmp0 (_tmp5_, _tmp6_) < 0) {
#line 2010 "function-manager.c"
						const gchar* _tmp7_;
						gchar* _tmp8_;
						const gchar* _tmp9_;
						gchar* _tmp10_;
						const gchar* _tmp11_;
						gchar* _tmp12_;
#line 222 "../lib/function-manager.vala"
						_tmp7_ = array[i];
#line 222 "../lib/function-manager.vala"
						_tmp8_ = g_strdup (_tmp7_);
#line 222 "../lib/function-manager.vala"
						_g_free0 (tmp);
#line 222 "../lib/function-manager.vala"
						tmp = _tmp8_;
#line 223 "../lib/function-manager.vala"
						_tmp9_ = array[i + 1];
#line 223 "../lib/function-manager.vala"
						_tmp10_ = g_strdup (_tmp9_);
#line 223 "../lib/function-manager.vala"
						_g_free0 (array[i]);
#line 223 "../lib/function-manager.vala"
						array[i] = _tmp10_;
#line 224 "../lib/function-manager.vala"
						_tmp11_ = tmp;
#line 224 "../lib/function-manager.vala"
						_tmp12_ = g_strdup (_tmp11_);
#line 224 "../lib/function-manager.vala"
						_g_free0 (array[i + 1]);
#line 224 "../lib/function-manager.vala"
						array[i + 1] = _tmp12_;
#line 225 "../lib/function-manager.vala"
						swapped = TRUE;
#line 2043 "function-manager.c"
					}
				}
			}
		}
	}
#line 229 "../lib/function-manager.vala"
	_tmp13_ = (array != NULL) ? _vala_array_dup1 (array, array_length1) : array;
#line 229 "../lib/function-manager.vala"
	_tmp13__length1 = array_length1;
#line 229 "../lib/function-manager.vala"
	_tmp14_ = _tmp13_;
#line 229 "../lib/function-manager.vala"
	_tmp14__length1 = _tmp13__length1;
#line 229 "../lib/function-manager.vala"
	if (result_length1) {
#line 229 "../lib/function-manager.vala"
		*result_length1 = _tmp14__length1;
#line 2061 "function-manager.c"
	}
#line 229 "../lib/function-manager.vala"
	result = _tmp14_;
#line 229 "../lib/function-manager.vala"
	_g_free0 (tmp);
#line 229 "../lib/function-manager.vala"
	return result;
#line 2069 "function-manager.c"
}

gchar**
function_manager_get_names (FunctionManager* self,
                            gint* result_length1)
{
	gchar** names = NULL;
	GHashTable* _tmp0_;
	gchar** _tmp1_;
	gint names_length1;
	gint _names_size_;
	GHashTableIter iter = {0};
	GHashTable* _tmp2_;
	gint i = 0;
	gchar* name = NULL;
	MathFunction* definition = NULL;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gint _tmp14_ = 0;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gchar** result;
#line 232 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "../lib/function-manager.vala"
	_tmp0_ = self->priv->functions;
#line 234 "../lib/function-manager.vala"
	_tmp1_ = g_new0 (gchar*, (g_hash_table_size (_tmp0_) + 1) + 1);
#line 234 "../lib/function-manager.vala"
	names = _tmp1_;
#line 234 "../lib/function-manager.vala"
	names_length1 = g_hash_table_size (_tmp0_) + 1;
#line 234 "../lib/function-manager.vala"
	_names_size_ = names_length1;
#line 236 "../lib/function-manager.vala"
	_tmp2_ = self->priv->functions;
#line 236 "../lib/function-manager.vala"
	g_hash_table_iter_init (&iter, _tmp2_);
#line 237 "../lib/function-manager.vala"
	i = 0;
#line 240 "../lib/function-manager.vala"
	while (TRUE) {
#line 2115 "function-manager.c"
		gconstpointer _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		gboolean _tmp5_;
		gchar* _tmp6_;
		MathFunction* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gint _tmp11_;
#line 240 "../lib/function-manager.vala"
		_tmp5_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp3_), (gpointer*) (&_tmp4_));
#line 240 "../lib/function-manager.vala"
		_g_free0 (name);
#line 240 "../lib/function-manager.vala"
		_tmp6_ = g_strdup ((const gchar*) _tmp3_);
#line 240 "../lib/function-manager.vala"
		name = _tmp6_;
#line 240 "../lib/function-manager.vala"
		_g_object_unref0 (definition);
#line 240 "../lib/function-manager.vala"
		_tmp7_ = _g_object_ref0 ((MathFunction*) _tmp4_);
#line 240 "../lib/function-manager.vala"
		definition = _tmp7_;
#line 240 "../lib/function-manager.vala"
		if (!_tmp5_) {
#line 240 "../lib/function-manager.vala"
			break;
#line 2144 "function-manager.c"
		}
#line 242 "../lib/function-manager.vala"
		_tmp8_ = names;
#line 242 "../lib/function-manager.vala"
		_tmp8__length1 = names_length1;
#line 242 "../lib/function-manager.vala"
		_tmp9_ = name;
#line 242 "../lib/function-manager.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 242 "../lib/function-manager.vala"
		_g_free0 (_tmp8_[i]);
#line 242 "../lib/function-manager.vala"
		_tmp8_[i] = _tmp10_;
#line 243 "../lib/function-manager.vala"
		_tmp11_ = i;
#line 243 "../lib/function-manager.vala"
		i = _tmp11_ + 1;
#line 2162 "function-manager.c"
	}
#line 245 "../lib/function-manager.vala"
	_tmp12_ = names;
#line 245 "../lib/function-manager.vala"
	_tmp12__length1 = names_length1;
#line 245 "../lib/function-manager.vala"
	_g_free0 (_tmp12_[i]);
#line 245 "../lib/function-manager.vala"
	_tmp12_[i] = NULL;
#line 247 "../lib/function-manager.vala"
	_tmp13_ = names;
#line 247 "../lib/function-manager.vala"
	_tmp13__length1 = names_length1;
#line 247 "../lib/function-manager.vala"
	_tmp15_ = function_manager_array_sort_string (self, _tmp13_, (gint) _tmp13__length1, &_tmp14_);
#line 247 "../lib/function-manager.vala"
	_tmp16_ = _tmp15_;
#line 247 "../lib/function-manager.vala"
	_tmp16__length1 = _tmp14_;
#line 247 "../lib/function-manager.vala"
	if (result_length1) {
#line 247 "../lib/function-manager.vala"
		*result_length1 = _tmp16__length1;
#line 2186 "function-manager.c"
	}
#line 247 "../lib/function-manager.vala"
	result = _tmp16_;
#line 247 "../lib/function-manager.vala"
	_g_object_unref0 (definition);
#line 247 "../lib/function-manager.vala"
	_g_free0 (name);
#line 247 "../lib/function-manager.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../lib/function-manager.vala"
	return result;
#line 2198 "function-manager.c"
}

/**
      * Adds a function to the manager, unless the given name is already taken
      * by a predefined function.
      * @return If the function was successfully added.
      */
static gboolean
function_manager_add (FunctionManager* self,
                      MathFunction* new_function)
{
	MathFunction* existing_function = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	MathFunction* _tmp2_;
	gboolean _tmp3_ = FALSE;
	MathFunction* _tmp4_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	MathFunction* _tmp10_;
	MathFunction* _tmp11_;
	gboolean result;
#line 255 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "../lib/function-manager.vala"
	g_return_val_if_fail (new_function != NULL, FALSE);
#line 257 "../lib/function-manager.vala"
	_tmp0_ = math_function_get_name (new_function);
#line 257 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 257 "../lib/function-manager.vala"
	_tmp2_ = function_manager_get (self, _tmp1_);
#line 257 "../lib/function-manager.vala"
	existing_function = _tmp2_;
#line 259 "../lib/function-manager.vala"
	_tmp4_ = existing_function;
#line 259 "../lib/function-manager.vala"
	if (_tmp4_ != NULL) {
#line 2239 "function-manager.c"
		MathFunction* _tmp5_;
#line 259 "../lib/function-manager.vala"
		_tmp5_ = existing_function;
#line 259 "../lib/function-manager.vala"
		_tmp3_ = !math_function_is_custom_function (_tmp5_);
#line 2245 "function-manager.c"
	} else {
#line 259 "../lib/function-manager.vala"
		_tmp3_ = FALSE;
#line 2249 "function-manager.c"
	}
#line 259 "../lib/function-manager.vala"
	if (_tmp3_) {
#line 260 "../lib/function-manager.vala"
		result = FALSE;
#line 260 "../lib/function-manager.vala"
		_g_object_unref0 (existing_function);
#line 260 "../lib/function-manager.vala"
		return result;
#line 2259 "function-manager.c"
	}
#line 262 "../lib/function-manager.vala"
	_tmp6_ = self->priv->functions;
#line 262 "../lib/function-manager.vala"
	_tmp7_ = math_function_get_name (new_function);
#line 262 "../lib/function-manager.vala"
	_tmp8_ = _tmp7_;
#line 262 "../lib/function-manager.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 262 "../lib/function-manager.vala"
	_tmp10_ = _g_object_ref0 (new_function);
#line 262 "../lib/function-manager.vala"
	g_hash_table_insert (_tmp6_, _tmp9_, _tmp10_);
#line 263 "../lib/function-manager.vala"
	_tmp11_ = existing_function;
#line 263 "../lib/function-manager.vala"
	if (_tmp11_ != NULL) {
#line 264 "../lib/function-manager.vala"
		g_signal_emit (self, function_manager_signals[FUNCTION_MANAGER_FUNCTION_EDITED_SIGNAL], 0, new_function);
#line 2279 "function-manager.c"
	} else {
#line 266 "../lib/function-manager.vala"
		g_signal_emit (self, function_manager_signals[FUNCTION_MANAGER_FUNCTION_ADDED_SIGNAL], 0, new_function);
#line 2283 "function-manager.c"
	}
#line 268 "../lib/function-manager.vala"
	result = TRUE;
#line 268 "../lib/function-manager.vala"
	_g_object_unref0 (existing_function);
#line 268 "../lib/function-manager.vala"
	return result;
#line 2291 "function-manager.c"
}

gboolean
function_manager_add_function_with_properties (FunctionManager* self,
                                               const gchar* name,
                                               const gchar* arguments,
                                               const gchar* description,
                                               Parser* root_parser)
{
	gchar* function_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	MathFunction* new_function = NULL;
	const gchar* _tmp8_;
	MathFunction* _tmp9_;
	gboolean _tmp10_ = FALSE;
	MathFunction* _tmp11_;
	gboolean is_function_added = FALSE;
	MathFunction* _tmp13_;
	gboolean result;
#line 271 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 271 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 271 "../lib/function-manager.vala"
	g_return_val_if_fail (arguments != NULL, FALSE);
#line 271 "../lib/function-manager.vala"
	g_return_val_if_fail (description != NULL, FALSE);
#line 273 "../lib/function-manager.vala"
	_tmp0_ = g_strconcat (name, "(", NULL);
#line 273 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 273 "../lib/function-manager.vala"
	_tmp2_ = g_strconcat (_tmp1_, arguments, NULL);
#line 273 "../lib/function-manager.vala"
	_tmp3_ = _tmp2_;
#line 273 "../lib/function-manager.vala"
	_tmp4_ = g_strconcat (_tmp3_, ")=", NULL);
#line 273 "../lib/function-manager.vala"
	_tmp5_ = _tmp4_;
#line 273 "../lib/function-manager.vala"
	_tmp6_ = g_strconcat (_tmp5_, description, NULL);
#line 273 "../lib/function-manager.vala"
	_tmp7_ = _tmp6_;
#line 273 "../lib/function-manager.vala"
	_g_free0 (_tmp5_);
#line 273 "../lib/function-manager.vala"
	_g_free0 (_tmp3_);
#line 273 "../lib/function-manager.vala"
	_g_free0 (_tmp1_);
#line 273 "../lib/function-manager.vala"
	function_string = _tmp7_;
#line 274 "../lib/function-manager.vala"
	_tmp8_ = function_string;
#line 274 "../lib/function-manager.vala"
	_tmp9_ = function_manager_parse_function_from_string (self, _tmp8_);
#line 274 "../lib/function-manager.vala"
	new_function = _tmp9_;
#line 276 "../lib/function-manager.vala"
	_tmp11_ = new_function;
#line 276 "../lib/function-manager.vala"
	if (_tmp11_ == NULL) {
#line 276 "../lib/function-manager.vala"
		_tmp10_ = TRUE;
#line 2362 "function-manager.c"
	} else {
		MathFunction* _tmp12_;
#line 276 "../lib/function-manager.vala"
		_tmp12_ = new_function;
#line 276 "../lib/function-manager.vala"
		_tmp10_ = math_function_validate (_tmp12_, root_parser) == FALSE;
#line 2369 "function-manager.c"
	}
#line 276 "../lib/function-manager.vala"
	if (_tmp10_) {
#line 278 "../lib/function-manager.vala"
		parser_set_error (root_parser, ERROR_CODE_INVALID, NULL, (guint) 0, (guint) 0);
#line 279 "../lib/function-manager.vala"
		result = FALSE;
#line 279 "../lib/function-manager.vala"
		_g_object_unref0 (new_function);
#line 279 "../lib/function-manager.vala"
		_g_free0 (function_string);
#line 279 "../lib/function-manager.vala"
		return result;
#line 2383 "function-manager.c"
	}
#line 282 "../lib/function-manager.vala"
	_tmp13_ = new_function;
#line 282 "../lib/function-manager.vala"
	is_function_added = function_manager_add (self, _tmp13_);
#line 283 "../lib/function-manager.vala"
	if (is_function_added) {
#line 284 "../lib/function-manager.vala"
		function_manager_save (self);
#line 2393 "function-manager.c"
	}
#line 286 "../lib/function-manager.vala"
	result = is_function_added;
#line 286 "../lib/function-manager.vala"
	_g_object_unref0 (new_function);
#line 286 "../lib/function-manager.vala"
	_g_free0 (function_string);
#line 286 "../lib/function-manager.vala"
	return result;
#line 2403 "function-manager.c"
}

MathFunction*
function_manager_get (FunctionManager* self,
                      const gchar* name)
{
	MathFunction* function = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	MathFunction* _tmp2_;
	MathFunction* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gconstpointer _tmp7_;
	MathFunction* _tmp8_;
	MathFunction* _tmp9_;
	MathFunction* result;
#line 289 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 291 "../lib/function-manager.vala"
	_tmp0_ = self->priv->functions;
#line 291 "../lib/function-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, name);
#line 291 "../lib/function-manager.vala"
	_tmp2_ = _g_object_ref0 ((MathFunction*) _tmp1_);
#line 291 "../lib/function-manager.vala"
	function = _tmp2_;
#line 292 "../lib/function-manager.vala"
	_tmp3_ = function;
#line 292 "../lib/function-manager.vala"
	if (_tmp3_ != NULL) {
#line 293 "../lib/function-manager.vala"
		result = function;
#line 293 "../lib/function-manager.vala"
		return result;
#line 2442 "function-manager.c"
	}
#line 294 "../lib/function-manager.vala"
	_tmp4_ = self->priv->functions;
#line 294 "../lib/function-manager.vala"
	_tmp5_ = g_utf8_strdown (name, (gssize) -1);
#line 294 "../lib/function-manager.vala"
	_tmp6_ = _tmp5_;
#line 294 "../lib/function-manager.vala"
	_tmp7_ = g_hash_table_lookup (_tmp4_, _tmp6_);
#line 294 "../lib/function-manager.vala"
	_tmp8_ = _g_object_ref0 ((MathFunction*) _tmp7_);
#line 294 "../lib/function-manager.vala"
	_tmp9_ = _tmp8_;
#line 294 "../lib/function-manager.vala"
	_g_free0 (_tmp6_);
#line 294 "../lib/function-manager.vala"
	result = _tmp9_;
#line 294 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 294 "../lib/function-manager.vala"
	return result;
#line 2464 "function-manager.c"
}

void
function_manager_delete (FunctionManager* self,
                         const gchar* name)
{
	MathFunction* function = NULL;
	MathFunction* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MathFunction* _tmp2_;
#line 297 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 297 "../lib/function-manager.vala"
	g_return_if_fail (name != NULL);
#line 299 "../lib/function-manager.vala"
	_tmp0_ = function_manager_get (self, name);
#line 299 "../lib/function-manager.vala"
	function = _tmp0_;
#line 300 "../lib/function-manager.vala"
	_tmp2_ = function;
#line 300 "../lib/function-manager.vala"
	if (_tmp2_ != NULL) {
#line 2487 "function-manager.c"
		MathFunction* _tmp3_;
#line 300 "../lib/function-manager.vala"
		_tmp3_ = function;
#line 300 "../lib/function-manager.vala"
		_tmp1_ = math_function_is_custom_function (_tmp3_);
#line 2493 "function-manager.c"
	} else {
#line 300 "../lib/function-manager.vala"
		_tmp1_ = FALSE;
#line 2497 "function-manager.c"
	}
#line 300 "../lib/function-manager.vala"
	if (_tmp1_) {
#line 2501 "function-manager.c"
		GHashTable* _tmp4_;
		MathFunction* _tmp5_;
#line 302 "../lib/function-manager.vala"
		_tmp4_ = self->priv->functions;
#line 302 "../lib/function-manager.vala"
		g_hash_table_remove (_tmp4_, name);
#line 303 "../lib/function-manager.vala"
		function_manager_save (self);
#line 304 "../lib/function-manager.vala"
		_tmp5_ = function;
#line 304 "../lib/function-manager.vala"
		g_signal_emit (self, function_manager_signals[FUNCTION_MANAGER_FUNCTION_DELETED_SIGNAL], 0, _tmp5_);
#line 2514 "function-manager.c"
	}
#line 297 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 2518 "function-manager.c"
}

gboolean
function_manager_is_function_defined (FunctionManager* self,
                                      const gchar* name)
{
	gchar* lower_name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp6_ = FALSE;
	GHashTable* _tmp7_;
	gboolean result;
#line 308 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 308 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 310 "../lib/function-manager.vala"
	_tmp0_ = g_utf8_strdown (name, (gssize) -1);
#line 310 "../lib/function-manager.vala"
	lower_name = _tmp0_;
#line 311 "../lib/function-manager.vala"
	_tmp2_ = lower_name;
#line 311 "../lib/function-manager.vala"
	if (g_str_has_prefix (_tmp2_, "log")) {
#line 2544 "function-manager.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 311 "../lib/function-manager.vala"
		_tmp3_ = lower_name;
#line 311 "../lib/function-manager.vala"
		_tmp4_ = string_substring (_tmp3_, (glong) 3, (glong) -1);
#line 311 "../lib/function-manager.vala"
		_tmp5_ = _tmp4_;
#line 311 "../lib/function-manager.vala"
		_tmp1_ = sub_atoi (_tmp5_) >= 0;
#line 311 "../lib/function-manager.vala"
		_g_free0 (_tmp5_);
#line 2558 "function-manager.c"
	} else {
#line 311 "../lib/function-manager.vala"
		_tmp1_ = FALSE;
#line 2562 "function-manager.c"
	}
#line 311 "../lib/function-manager.vala"
	if (_tmp1_) {
#line 312 "../lib/function-manager.vala"
		result = TRUE;
#line 312 "../lib/function-manager.vala"
		_g_free0 (lower_name);
#line 312 "../lib/function-manager.vala"
		return result;
#line 2572 "function-manager.c"
	}
#line 313 "../lib/function-manager.vala"
	_tmp7_ = self->priv->functions;
#line 313 "../lib/function-manager.vala"
	if (g_hash_table_contains (_tmp7_, name)) {
#line 313 "../lib/function-manager.vala"
		_tmp6_ = TRUE;
#line 2580 "function-manager.c"
	} else {
		GHashTable* _tmp8_;
		const gchar* _tmp9_;
#line 313 "../lib/function-manager.vala"
		_tmp8_ = self->priv->functions;
#line 313 "../lib/function-manager.vala"
		_tmp9_ = lower_name;
#line 313 "../lib/function-manager.vala"
		_tmp6_ = g_hash_table_contains (_tmp8_, _tmp9_);
#line 2590 "function-manager.c"
	}
#line 313 "../lib/function-manager.vala"
	result = _tmp6_;
#line 313 "../lib/function-manager.vala"
	_g_free0 (lower_name);
#line 313 "../lib/function-manager.vala"
	return result;
#line 2598 "function-manager.c"
}

static Number**
_vala_array_dup2 (Number** self,
                  gssize length)
{
#line 319 "../lib/function-manager.vala"
	if (length >= 0) {
#line 2607 "function-manager.c"
		Number** result;
		gssize i;
#line 319 "../lib/function-manager.vala"
		result = g_new0 (Number*, length + 1);
#line 319 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 2614 "function-manager.c"
			Number* _tmp0_;
#line 319 "../lib/function-manager.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 319 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 2620 "function-manager.c"
		}
#line 319 "../lib/function-manager.vala"
		return result;
#line 2624 "function-manager.c"
	}
#line 319 "../lib/function-manager.vala"
	return NULL;
#line 2628 "function-manager.c"
}

static void
_vala_array_add4 (Number** * array,
                  gint* length,
                  gint* size,
                  Number* value)
{
#line 323 "../lib/function-manager.vala"
	if ((*length) == (*size)) {
#line 323 "../lib/function-manager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 323 "../lib/function-manager.vala"
		*array = g_renew (Number*, *array, (*size) + 1);
#line 2643 "function-manager.c"
	}
#line 323 "../lib/function-manager.vala"
	(*array)[(*length)++] = value;
#line 323 "../lib/function-manager.vala"
	(*array)[*length] = NULL;
#line 2649 "function-manager.c"
}

Number*
function_manager_evaluate_function (FunctionManager* self,
                                    const gchar* name,
                                    Number** arguments,
                                    gint arguments_length1,
                                    Parser* parser)
{
	gchar* lower_name = NULL;
	gchar* _tmp0_;
	Number** args = NULL;
	Number** _tmp1_;
	gint _tmp1__length1;
	gint args_length1;
	gint _args_size_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	MathFunction* function = NULL;
	MathFunction* _tmp14_;
	MathFunction* _tmp15_;
	MathFunction* _tmp16_;
	Number** _tmp17_;
	gint _tmp17__length1;
	Number* _tmp18_;
	Number* result;
#line 316 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 316 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 316 "../lib/function-manager.vala"
	g_return_val_if_fail (parser != NULL, NULL);
#line 318 "../lib/function-manager.vala"
	_tmp0_ = g_utf8_strdown (name, (gssize) -1);
#line 318 "../lib/function-manager.vala"
	lower_name = _tmp0_;
#line 319 "../lib/function-manager.vala"
	_tmp1_ = (arguments != NULL) ? _vala_array_dup2 (arguments, arguments_length1) : arguments;
#line 319 "../lib/function-manager.vala"
	_tmp1__length1 = arguments_length1;
#line 319 "../lib/function-manager.vala"
	args = _tmp1_;
#line 319 "../lib/function-manager.vala"
	args_length1 = _tmp1__length1;
#line 319 "../lib/function-manager.vala"
	_args_size_ = args_length1;
#line 320 "../lib/function-manager.vala"
	_tmp3_ = lower_name;
#line 320 "../lib/function-manager.vala"
	if (g_str_has_prefix (_tmp3_, "log")) {
#line 2700 "function-manager.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 320 "../lib/function-manager.vala"
		_tmp4_ = lower_name;
#line 320 "../lib/function-manager.vala"
		_tmp5_ = string_substring (_tmp4_, (glong) 3, (glong) -1);
#line 320 "../lib/function-manager.vala"
		_tmp6_ = _tmp5_;
#line 320 "../lib/function-manager.vala"
		_tmp2_ = sub_atoi (_tmp6_) > 0;
#line 320 "../lib/function-manager.vala"
		_g_free0 (_tmp6_);
#line 2714 "function-manager.c"
	} else {
#line 320 "../lib/function-manager.vala"
		_tmp2_ = FALSE;
#line 2718 "function-manager.c"
	}
#line 320 "../lib/function-manager.vala"
	if (_tmp2_) {
#line 2722 "function-manager.c"
		Number* log_base = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		Number* _tmp10_;
		Number* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
#line 322 "../lib/function-manager.vala"
		_tmp7_ = lower_name;
#line 322 "../lib/function-manager.vala"
		_tmp8_ = string_substring (_tmp7_, (glong) 3, (glong) -1);
#line 322 "../lib/function-manager.vala"
		_tmp9_ = _tmp8_;
#line 322 "../lib/function-manager.vala"
		_tmp10_ = number_new_integer ((gint64) sub_atoi (_tmp9_), (gint64) 0);
#line 322 "../lib/function-manager.vala"
		_tmp11_ = _tmp10_;
#line 322 "../lib/function-manager.vala"
		_g_free0 (_tmp9_);
#line 322 "../lib/function-manager.vala"
		log_base = _tmp11_;
#line 323 "../lib/function-manager.vala"
		_tmp12_ = log_base;
#line 323 "../lib/function-manager.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 323 "../lib/function-manager.vala"
		_vala_array_add4 (&args, &args_length1, &_args_size_, _tmp13_);
#line 324 "../lib/function-manager.vala"
		name = "log";
#line 320 "../lib/function-manager.vala"
		_g_object_unref0 (log_base);
#line 2755 "function-manager.c"
	}
#line 327 "../lib/function-manager.vala"
	_tmp14_ = function_manager_get (self, name);
#line 327 "../lib/function-manager.vala"
	function = _tmp14_;
#line 328 "../lib/function-manager.vala"
	_tmp15_ = function;
#line 328 "../lib/function-manager.vala"
	if (_tmp15_ == NULL) {
#line 330 "../lib/function-manager.vala"
		parser_set_error (parser, ERROR_CODE_UNKNOWN_FUNCTION, NULL, (guint) 0, (guint) 0);
#line 331 "../lib/function-manager.vala"
		result = NULL;
#line 331 "../lib/function-manager.vala"
		_g_object_unref0 (function);
#line 331 "../lib/function-manager.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_object_unref), NULL);
#line 331 "../lib/function-manager.vala"
		_g_free0 (lower_name);
#line 331 "../lib/function-manager.vala"
		return result;
#line 2777 "function-manager.c"
	}
#line 334 "../lib/function-manager.vala"
	_tmp16_ = function;
#line 334 "../lib/function-manager.vala"
	_tmp17_ = args;
#line 334 "../lib/function-manager.vala"
	_tmp17__length1 = args_length1;
#line 334 "../lib/function-manager.vala"
	_tmp18_ = math_function_evaluate (_tmp16_, _tmp17_, (gint) _tmp17__length1, parser);
#line 334 "../lib/function-manager.vala"
	result = _tmp18_;
#line 334 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 334 "../lib/function-manager.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_object_unref), NULL);
#line 334 "../lib/function-manager.vala"
	_g_free0 (lower_name);
#line 334 "../lib/function-manager.vala"
	return result;
#line 2797 "function-manager.c"
}

static MathFunction**
_vala_array_dup3 (MathFunction** self,
                  gssize length)
{
#line 340 "../lib/function-manager.vala"
	if (length >= 0) {
#line 2806 "function-manager.c"
		MathFunction** result;
		gssize i;
#line 340 "../lib/function-manager.vala"
		result = g_new0 (MathFunction*, length + 1);
#line 340 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 2813 "function-manager.c"
			MathFunction* _tmp0_;
#line 340 "../lib/function-manager.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 340 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 2819 "function-manager.c"
		}
#line 340 "../lib/function-manager.vala"
		return result;
#line 2823 "function-manager.c"
	}
#line 340 "../lib/function-manager.vala"
	return NULL;
#line 2827 "function-manager.c"
}

static MathFunction**
_vala_array_dup4 (MathFunction** self,
                  gssize length)
{
#line 362 "../lib/function-manager.vala"
	if (length >= 0) {
#line 2836 "function-manager.c"
		MathFunction** result;
		gssize i;
#line 362 "../lib/function-manager.vala"
		result = g_new0 (MathFunction*, length + 1);
#line 362 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 2843 "function-manager.c"
			MathFunction* _tmp0_;
#line 362 "../lib/function-manager.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 362 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 2849 "function-manager.c"
		}
#line 362 "../lib/function-manager.vala"
		return result;
#line 2853 "function-manager.c"
	}
#line 362 "../lib/function-manager.vala"
	return NULL;
#line 2857 "function-manager.c"
}

static MathFunction**
function_manager_array_sort_math_function (FunctionManager* self,
                                           MathFunction** array,
                                           gint array_length1,
                                           gint* result_length1)
{
	gboolean swapped = FALSE;
	gint _tmp2_ = 0;
	MathFunction* _tmp3_;
	gint j = 0;
	MathFunction* tmp = NULL;
	MathFunction** _tmp21_;
	gint _tmp21__length1;
	MathFunction** _tmp22_;
	gint _tmp22__length1;
	MathFunction** result;
#line 337 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 339 "../lib/function-manager.vala"
	if (array_length1 == 0) {
#line 2880 "function-manager.c"
		MathFunction** _tmp0_;
		gint _tmp0__length1;
		MathFunction** _tmp1_;
		gint _tmp1__length1;
#line 340 "../lib/function-manager.vala"
		_tmp0_ = (array != NULL) ? _vala_array_dup3 (array, array_length1) : array;
#line 340 "../lib/function-manager.vala"
		_tmp0__length1 = array_length1;
#line 340 "../lib/function-manager.vala"
		_tmp1_ = _tmp0_;
#line 340 "../lib/function-manager.vala"
		_tmp1__length1 = _tmp0__length1;
#line 340 "../lib/function-manager.vala"
		if (result_length1) {
#line 340 "../lib/function-manager.vala"
			*result_length1 = _tmp1__length1;
#line 2897 "function-manager.c"
		}
#line 340 "../lib/function-manager.vala"
		result = _tmp1_;
#line 340 "../lib/function-manager.vala"
		return result;
#line 2903 "function-manager.c"
	}
#line 341 "../lib/function-manager.vala"
	swapped = TRUE;
#line 342 "../lib/function-manager.vala"
	_tmp3_ = array[array_length1 - 1];
#line 342 "../lib/function-manager.vala"
	if (_tmp3_ == NULL) {
#line 342 "../lib/function-manager.vala"
		_tmp2_ = 1;
#line 2913 "function-manager.c"
	} else {
#line 342 "../lib/function-manager.vala"
		_tmp2_ = 0;
#line 2917 "function-manager.c"
	}
#line 342 "../lib/function-manager.vala"
	j = _tmp2_;
#line 345 "../lib/function-manager.vala"
	while (TRUE) {
#line 2923 "function-manager.c"
		gint _tmp4_;
		gint _tmp5_;
#line 345 "../lib/function-manager.vala"
		if (!swapped) {
#line 345 "../lib/function-manager.vala"
			break;
#line 2930 "function-manager.c"
		}
#line 347 "../lib/function-manager.vala"
		swapped = FALSE;
#line 348 "../lib/function-manager.vala"
		_tmp4_ = j;
#line 348 "../lib/function-manager.vala"
		j = _tmp4_ + 1;
#line 349 "../lib/function-manager.vala"
		_tmp5_ = j;
#line 349 "../lib/function-manager.vala"
		_vala_assert ((0 <= _tmp5_) && (_tmp5_ <= array_length1), "0 <= j <= array.length");
#line 2942 "function-manager.c"
		{
			gint i = 0;
#line 350 "../lib/function-manager.vala"
			i = 0;
#line 2947 "function-manager.c"
			{
				gboolean _tmp6_ = FALSE;
#line 350 "../lib/function-manager.vala"
				_tmp6_ = TRUE;
#line 350 "../lib/function-manager.vala"
				while (TRUE) {
#line 2954 "function-manager.c"
					gint _tmp8_;
					MathFunction* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					MathFunction* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 350 "../lib/function-manager.vala"
					if (!_tmp6_) {
#line 2964 "function-manager.c"
						gint _tmp7_;
#line 350 "../lib/function-manager.vala"
						_tmp7_ = i;
#line 350 "../lib/function-manager.vala"
						i = _tmp7_ + 1;
#line 2970 "function-manager.c"
					}
#line 350 "../lib/function-manager.vala"
					_tmp6_ = FALSE;
#line 350 "../lib/function-manager.vala"
					if (!(i < (array_length1 - j))) {
#line 350 "../lib/function-manager.vala"
						break;
#line 2978 "function-manager.c"
					}
#line 352 "../lib/function-manager.vala"
					_tmp8_ = i + 1;
#line 352 "../lib/function-manager.vala"
					_vala_assert ((0 <= _tmp8_) && (_tmp8_ < array_length1), "0 <= (i+1) < array.length");
#line 353 "../lib/function-manager.vala"
					_tmp9_ = array[i];
#line 353 "../lib/function-manager.vala"
					_tmp10_ = math_function_get_name (_tmp9_);
#line 353 "../lib/function-manager.vala"
					_tmp11_ = _tmp10_;
#line 353 "../lib/function-manager.vala"
					_tmp12_ = array[i + 1];
#line 353 "../lib/function-manager.vala"
					_tmp13_ = math_function_get_name (_tmp12_);
#line 353 "../lib/function-manager.vala"
					_tmp14_ = _tmp13_;
#line 353 "../lib/function-manager.vala"
					if (g_strcmp0 (_tmp11_, _tmp14_) > 0) {
#line 2998 "function-manager.c"
						MathFunction* _tmp15_;
						MathFunction* _tmp16_;
						MathFunction* _tmp17_;
						MathFunction* _tmp18_;
						MathFunction* _tmp19_;
						MathFunction* _tmp20_;
#line 355 "../lib/function-manager.vala"
						_tmp15_ = array[i];
#line 355 "../lib/function-manager.vala"
						_tmp16_ = _g_object_ref0 (_tmp15_);
#line 355 "../lib/function-manager.vala"
						_g_object_unref0 (tmp);
#line 355 "../lib/function-manager.vala"
						tmp = _tmp16_;
#line 356 "../lib/function-manager.vala"
						_tmp17_ = array[i + 1];
#line 356 "../lib/function-manager.vala"
						_tmp18_ = _g_object_ref0 (_tmp17_);
#line 356 "../lib/function-manager.vala"
						_g_object_unref0 (array[i]);
#line 356 "../lib/function-manager.vala"
						array[i] = _tmp18_;
#line 357 "../lib/function-manager.vala"
						_tmp19_ = tmp;
#line 357 "../lib/function-manager.vala"
						_tmp20_ = _g_object_ref0 (_tmp19_);
#line 357 "../lib/function-manager.vala"
						_g_object_unref0 (array[i + 1]);
#line 357 "../lib/function-manager.vala"
						array[i + 1] = _tmp20_;
#line 358 "../lib/function-manager.vala"
						swapped = TRUE;
#line 3031 "function-manager.c"
					}
				}
			}
		}
	}
#line 362 "../lib/function-manager.vala"
	_tmp21_ = (array != NULL) ? _vala_array_dup4 (array, array_length1) : array;
#line 362 "../lib/function-manager.vala"
	_tmp21__length1 = array_length1;
#line 362 "../lib/function-manager.vala"
	_tmp22_ = _tmp21_;
#line 362 "../lib/function-manager.vala"
	_tmp22__length1 = _tmp21__length1;
#line 362 "../lib/function-manager.vala"
	if (result_length1) {
#line 362 "../lib/function-manager.vala"
		*result_length1 = _tmp22__length1;
#line 3049 "function-manager.c"
	}
#line 362 "../lib/function-manager.vala"
	result = _tmp22_;
#line 362 "../lib/function-manager.vala"
	_g_object_unref0 (tmp);
#line 362 "../lib/function-manager.vala"
	return result;
#line 3057 "function-manager.c"
}

static void
_vala_array_add5 (MathFunction** * array,
                  gint* length,
                  gint* size,
                  MathFunction* value)
{
#line 377 "../lib/function-manager.vala"
	if ((*length) == (*size)) {
#line 377 "../lib/function-manager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 377 "../lib/function-manager.vala"
		*array = g_renew (MathFunction*, *array, (*size) + 1);
#line 3072 "function-manager.c"
	}
#line 377 "../lib/function-manager.vala"
	(*array)[(*length)++] = value;
#line 377 "../lib/function-manager.vala"
	(*array)[*length] = NULL;
#line 3078 "function-manager.c"
}

MathFunction**
function_manager_functions_eligible_for_autocompletion_for_text (FunctionManager* self,
                                                                 const gchar* display_text,
                                                                 gint* result_length1)
{
	MathFunction** eligible_functions = NULL;
	MathFunction** _tmp0_;
	gint eligible_functions_length1;
	gint _eligible_functions_size_;
	gchar* display_text_case_insensitive = NULL;
	gchar* _tmp1_;
	GHashTableIter iter = {0};
	GHashTable* _tmp2_;
	gchar* function_name = NULL;
	MathFunction* function = NULL;
	MathFunction** _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_ = 0;
	MathFunction** _tmp16_;
	MathFunction** _tmp17_;
	gint _tmp17__length1;
	MathFunction** result;
#line 365 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 365 "../lib/function-manager.vala"
	g_return_val_if_fail (display_text != NULL, NULL);
#line 367 "../lib/function-manager.vala"
	_tmp0_ = g_new0 (MathFunction*, 0 + 1);
#line 367 "../lib/function-manager.vala"
	eligible_functions = _tmp0_;
#line 367 "../lib/function-manager.vala"
	eligible_functions_length1 = 0;
#line 367 "../lib/function-manager.vala"
	_eligible_functions_size_ = eligible_functions_length1;
#line 369 "../lib/function-manager.vala"
	_tmp1_ = g_utf8_strdown (display_text, (gssize) -1);
#line 369 "../lib/function-manager.vala"
	display_text_case_insensitive = _tmp1_;
#line 370 "../lib/function-manager.vala"
	_tmp2_ = self->priv->functions;
#line 370 "../lib/function-manager.vala"
	g_hash_table_iter_init (&iter, _tmp2_);
#line 373 "../lib/function-manager.vala"
	while (TRUE) {
#line 3125 "function-manager.c"
		gconstpointer _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		gboolean _tmp5_;
		gchar* _tmp6_;
		MathFunction* _tmp7_;
		gchar* function_name_case_insensitive = NULL;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 373 "../lib/function-manager.vala"
		_tmp5_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp3_), (gpointer*) (&_tmp4_));
#line 373 "../lib/function-manager.vala"
		_g_free0 (function_name);
#line 373 "../lib/function-manager.vala"
		_tmp6_ = g_strdup ((const gchar*) _tmp3_);
#line 373 "../lib/function-manager.vala"
		function_name = _tmp6_;
#line 373 "../lib/function-manager.vala"
		_g_object_unref0 (function);
#line 373 "../lib/function-manager.vala"
		_tmp7_ = _g_object_ref0 ((MathFunction*) _tmp4_);
#line 373 "../lib/function-manager.vala"
		function = _tmp7_;
#line 373 "../lib/function-manager.vala"
		if (!_tmp5_) {
#line 373 "../lib/function-manager.vala"
			break;
#line 3154 "function-manager.c"
		}
#line 375 "../lib/function-manager.vala"
		_tmp8_ = function_name;
#line 375 "../lib/function-manager.vala"
		_tmp9_ = g_utf8_strdown (_tmp8_, (gssize) -1);
#line 375 "../lib/function-manager.vala"
		function_name_case_insensitive = _tmp9_;
#line 376 "../lib/function-manager.vala"
		_tmp10_ = function_name_case_insensitive;
#line 376 "../lib/function-manager.vala"
		_tmp11_ = display_text_case_insensitive;
#line 376 "../lib/function-manager.vala"
		if (g_str_has_prefix (_tmp10_, _tmp11_)) {
#line 3168 "function-manager.c"
			MathFunction* _tmp12_;
			MathFunction* _tmp13_;
#line 377 "../lib/function-manager.vala"
			_tmp12_ = function;
#line 377 "../lib/function-manager.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 377 "../lib/function-manager.vala"
			_vala_array_add5 (&eligible_functions, &eligible_functions_length1, &_eligible_functions_size_, _tmp13_);
#line 3177 "function-manager.c"
		}
#line 373 "../lib/function-manager.vala"
		_g_free0 (function_name_case_insensitive);
#line 3181 "function-manager.c"
	}
#line 380 "../lib/function-manager.vala"
	_tmp14_ = eligible_functions;
#line 380 "../lib/function-manager.vala"
	_tmp14__length1 = eligible_functions_length1;
#line 380 "../lib/function-manager.vala"
	_tmp16_ = function_manager_array_sort_math_function (self, _tmp14_, (gint) _tmp14__length1, &_tmp15_);
#line 380 "../lib/function-manager.vala"
	_tmp17_ = _tmp16_;
#line 380 "../lib/function-manager.vala"
	_tmp17__length1 = _tmp15_;
#line 380 "../lib/function-manager.vala"
	if (result_length1) {
#line 380 "../lib/function-manager.vala"
		*result_length1 = _tmp17__length1;
#line 3197 "function-manager.c"
	}
#line 380 "../lib/function-manager.vala"
	result = _tmp17_;
#line 380 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 380 "../lib/function-manager.vala"
	_g_free0 (function_name);
#line 380 "../lib/function-manager.vala"
	_g_free0 (display_text_case_insensitive);
#line 380 "../lib/function-manager.vala"
	eligible_functions = (_vala_array_free (eligible_functions, eligible_functions_length1, (GDestroyNotify) g_object_unref), NULL);
#line 380 "../lib/function-manager.vala"
	return result;
#line 3211 "function-manager.c"
}

static void
function_manager_class_init (FunctionManagerClass * klass,
                             gpointer klass_data)
{
#line 13 "../lib/function-manager.vala"
	function_manager_parent_class = g_type_class_peek_parent (klass);
#line 13 "../lib/function-manager.vala"
	g_type_class_adjust_private_offset (klass, &FunctionManager_private_offset);
#line 13 "../lib/function-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = function_manager_finalize;
#line 13 "../lib/function-manager.vala"
	function_manager_signals[FUNCTION_MANAGER_FUNCTION_ADDED_SIGNAL] = g_signal_new ("function-added", TYPE_FUNCTION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_MATH_FUNCTION);
#line 13 "../lib/function-manager.vala"
	function_manager_signals[FUNCTION_MANAGER_FUNCTION_EDITED_SIGNAL] = g_signal_new ("function-edited", TYPE_FUNCTION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_MATH_FUNCTION);
#line 13 "../lib/function-manager.vala"
	function_manager_signals[FUNCTION_MANAGER_FUNCTION_DELETED_SIGNAL] = g_signal_new ("function-deleted", TYPE_FUNCTION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_MATH_FUNCTION);
#line 3230 "function-manager.c"
}

static void
function_manager_instance_init (FunctionManager * self,
                                gpointer klass)
{
#line 13 "../lib/function-manager.vala"
	self->priv = function_manager_get_instance_private (self);
#line 3239 "function-manager.c"
}

static void
function_manager_finalize (GObject * obj)
{
	FunctionManager * self;
#line 13 "../lib/function-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FUNCTION_MANAGER, FunctionManager);
#line 15 "../lib/function-manager.vala"
	_g_free0 (self->priv->file_name);
#line 16 "../lib/function-manager.vala"
	_g_hash_table_unref0 (self->priv->functions);
#line 17 "../lib/function-manager.vala"
	_g_object_unref0 (self->priv->serializer);
#line 13 "../lib/function-manager.vala"
	G_OBJECT_CLASS (function_manager_parent_class)->finalize (obj);
#line 3256 "function-manager.c"
}

static GType
function_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FunctionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) function_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FunctionManager), 0, (GInstanceInitFunc) function_manager_instance_init, NULL };
	GType function_manager_type_id;
	function_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "FunctionManager", &g_define_type_info, 0);
	FunctionManager_private_offset = g_type_add_instance_private (function_manager_type_id, sizeof (FunctionManagerPrivate));
	return function_manager_type_id;
}

GType
function_manager_get_type (void)
{
	static volatile gsize function_manager_type_id__once = 0;
	if (g_once_init_enter (&function_manager_type_id__once)) {
		GType function_manager_type_id;
		function_manager_type_id = function_manager_get_type_once ();
		g_once_init_leave (&function_manager_type_id__once, function_manager_type_id);
	}
	return function_manager_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

