/* serializer.c generated by valac 0.56.15, the Vala compiler
 * generated from serializer.vala, do not modify */

/*
 * Copyright (C) 2010 Robin Sonefors
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "calculator.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <langinfo.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERIALIZER_0_PROPERTY,
	SERIALIZER_ERROR_PROPERTY,
	SERIALIZER_NUM_PROPERTIES
};
static GParamSpec* serializer_properties[SERIALIZER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SerializerPrivate {
	gint leading_digits;
	gint trailing_digits;
	DisplayFormat format;
	gboolean show_tsep;
	gboolean show_zeroes;
	gint number_base;
	guint representation_base;
	gunichar radix;
	gunichar tsep;
	gint tsep_count;
	gchar* _error;
};

static gint Serializer_private_offset;
static gpointer serializer_parent_class = NULL;

static gchar* serializer_cast_to_string (Serializer* self,
                                  Number* x,
                                  gint* n_digits);
static gchar* serializer_cast_to_exponential_string (Serializer* self,
                                              Number* x,
                                              gboolean eng_format,
                                              gint* n_digits);
static void serializer_cast_to_string_real (Serializer* self,
                                     Number* x,
                                     gint number_base,
                                     gboolean force_sign,
                                     gint* n_digits,
                                     GString* string);
static gint serializer_cast_to_exponential_string_real (Serializer* self,
                                                 Number* x,
                                                 GString* string,
                                                 gboolean eng_format,
                                                 gint* n_digits);
static void serializer_append_exponent (Serializer* self,
                                 GString* string,
                                 gint exponent);
static void serializer_finalize (GObject * obj);
static GType serializer_get_type_once (void);
static void _vala_serializer_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_serializer_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static GType
display_format_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_FORMAT_AUTOMATIC, "DISPLAY_FORMAT_AUTOMATIC", "automatic"}, {DISPLAY_FORMAT_FIXED, "DISPLAY_FORMAT_FIXED", "fixed"}, {DISPLAY_FORMAT_SCIENTIFIC, "DISPLAY_FORMAT_SCIENTIFIC", "scientific"}, {DISPLAY_FORMAT_ENGINEERING, "DISPLAY_FORMAT_ENGINEERING", "engineering"}, {0, NULL, NULL}};
	GType display_format_type_id;
	display_format_type_id = g_enum_register_static ("DisplayFormat", values);
	return display_format_type_id;
}

GType
display_format_get_type (void)
{
	static volatile gsize display_format_type_id__once = 0;
	if (g_once_init_enter (&display_format_type_id__once)) {
		GType display_format_type_id;
		display_format_type_id = display_format_get_type_once ();
		g_once_init_leave (&display_format_type_id__once, display_format_type_id);
	}
	return display_format_type_id__once;
}

static inline gpointer
serializer_get_instance_private (Serializer* self)
{
	return G_STRUCT_MEMBER_P (self, Serializer_private_offset);
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 130 "serializer.c"
}

Serializer*
serializer_construct (GType object_type,
                      DisplayFormat format,
                      gint number_base,
                      gint trailing_digits)
{
	Serializer * self = NULL;
	gchar* radix_string = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* tsep_string = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
#line 38 "../lib/serializer.vala"
	self = (Serializer*) g_object_new (object_type, NULL);
#line 40 "../lib/serializer.vala"
	_tmp0_ = nl_langinfo (RADIXCHAR);
#line 40 "../lib/serializer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 40 "../lib/serializer.vala"
	radix_string = _tmp1_;
#line 41 "../lib/serializer.vala"
	_tmp3_ = radix_string;
#line 41 "../lib/serializer.vala"
	if (_tmp3_ != NULL) {
#line 162 "serializer.c"
		const gchar* _tmp4_;
#line 41 "../lib/serializer.vala"
		_tmp4_ = radix_string;
#line 41 "../lib/serializer.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 168 "serializer.c"
	} else {
#line 41 "../lib/serializer.vala"
		_tmp2_ = FALSE;
#line 172 "serializer.c"
	}
#line 41 "../lib/serializer.vala"
	if (_tmp2_) {
#line 176 "serializer.c"
		gchar* radix_utf8 = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 42 "../lib/serializer.vala"
		_tmp5_ = radix_string;
#line 42 "../lib/serializer.vala"
		_tmp6_ = g_locale_to_utf8 (_tmp5_, (gssize) -1, NULL, NULL, NULL);
#line 42 "../lib/serializer.vala"
		radix_utf8 = _tmp6_;
#line 43 "../lib/serializer.vala"
		_tmp7_ = radix_utf8;
#line 43 "../lib/serializer.vala"
		if (_tmp7_ != NULL) {
#line 191 "serializer.c"
			const gchar* _tmp8_;
#line 44 "../lib/serializer.vala"
			_tmp8_ = radix_utf8;
#line 44 "../lib/serializer.vala"
			self->priv->radix = string_get_char (_tmp8_, (glong) 0);
#line 197 "serializer.c"
		} else {
#line 46 "../lib/serializer.vala"
			self->priv->radix = (gunichar) '.';
#line 201 "serializer.c"
		}
#line 41 "../lib/serializer.vala"
		_g_free0 (radix_utf8);
#line 205 "serializer.c"
	} else {
#line 49 "../lib/serializer.vala"
		self->priv->radix = (gunichar) '.';
#line 209 "serializer.c"
	}
#line 50 "../lib/serializer.vala"
	_tmp9_ = nl_langinfo (THOUSEP);
#line 50 "../lib/serializer.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 50 "../lib/serializer.vala"
	tsep_string = _tmp10_;
#line 51 "../lib/serializer.vala"
	_tmp12_ = tsep_string;
#line 51 "../lib/serializer.vala"
	if (_tmp12_ != NULL) {
#line 221 "serializer.c"
		const gchar* _tmp13_;
#line 51 "../lib/serializer.vala"
		_tmp13_ = tsep_string;
#line 51 "../lib/serializer.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "") != 0;
#line 227 "serializer.c"
	} else {
#line 51 "../lib/serializer.vala"
		_tmp11_ = FALSE;
#line 231 "serializer.c"
	}
#line 51 "../lib/serializer.vala"
	if (_tmp11_) {
#line 235 "serializer.c"
		gchar* tsep_utf8 = NULL;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
#line 52 "../lib/serializer.vala"
		_tmp14_ = tsep_string;
#line 52 "../lib/serializer.vala"
		_tmp15_ = g_locale_to_utf8 (_tmp14_, (gssize) -1, NULL, NULL, NULL);
#line 52 "../lib/serializer.vala"
		tsep_utf8 = _tmp15_;
#line 53 "../lib/serializer.vala"
		_tmp16_ = tsep_utf8;
#line 53 "../lib/serializer.vala"
		if (_tmp16_ != NULL) {
#line 250 "serializer.c"
			const gchar* _tmp17_;
#line 54 "../lib/serializer.vala"
			_tmp17_ = tsep_utf8;
#line 54 "../lib/serializer.vala"
			self->priv->tsep = string_get_char (_tmp17_, (glong) 0);
#line 256 "serializer.c"
		} else {
#line 56 "../lib/serializer.vala"
			self->priv->tsep = (gunichar) ' ';
#line 260 "serializer.c"
		}
#line 51 "../lib/serializer.vala"
		_g_free0 (tsep_utf8);
#line 264 "serializer.c"
	} else {
#line 59 "../lib/serializer.vala"
		self->priv->tsep = (gunichar) ' ';
#line 268 "serializer.c"
	}
#line 60 "../lib/serializer.vala"
	self->priv->tsep_count = 3;
#line 62 "../lib/serializer.vala"
	self->priv->number_base = number_base;
#line 63 "../lib/serializer.vala"
	self->priv->representation_base = (guint) number_base;
#line 64 "../lib/serializer.vala"
	self->priv->leading_digits = 12;
#line 65 "../lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 66 "../lib/serializer.vala"
	self->priv->show_zeroes = FALSE;
#line 67 "../lib/serializer.vala"
	self->priv->show_tsep = FALSE;
#line 68 "../lib/serializer.vala"
	self->priv->format = format;
#line 38 "../lib/serializer.vala"
	_g_free0 (tsep_string);
#line 38 "../lib/serializer.vala"
	_g_free0 (radix_string);
#line 38 "../lib/serializer.vala"
	return self;
#line 292 "serializer.c"
}

Serializer*
serializer_new (DisplayFormat format,
                gint number_base,
                gint trailing_digits)
{
#line 38 "../lib/serializer.vala"
	return serializer_construct (TYPE_SERIALIZER, format, number_base, trailing_digits);
#line 302 "serializer.c"
}

gchar*
serializer_to_string (Serializer* self,
                      Number* x)
{
	gchar* result;
#line 71 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 74 "../lib/serializer.vala"
	if (self->priv->representation_base != ((guint) self->priv->number_base)) {
#line 316 "serializer.c"
		gint n_digits = 0;
		gchar* _tmp0_;
#line 76 "../lib/serializer.vala"
		n_digits = 0;
#line 77 "../lib/serializer.vala"
		_tmp0_ = serializer_cast_to_string (self, x, &n_digits);
#line 77 "../lib/serializer.vala"
		result = _tmp0_;
#line 77 "../lib/serializer.vala"
		return result;
#line 327 "serializer.c"
	}
#line 79 "../lib/serializer.vala"
	switch (self->priv->format) {
#line 331 "serializer.c"
		default:
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_AUTOMATIC:
#line 335 "serializer.c"
		{
			gint n_digits = 0;
			gchar* s0 = NULL;
			gchar* _tmp1_;
#line 83 "../lib/serializer.vala"
			n_digits = 0;
#line 84 "../lib/serializer.vala"
			_tmp1_ = serializer_cast_to_string (self, x, &n_digits);
#line 84 "../lib/serializer.vala"
			s0 = _tmp1_;
#line 86 "../lib/serializer.vala"
			switch (serializer_get_base (self)) {
#line 86 "../lib/serializer.vala"
				case 2:
#line 350 "serializer.c"
				{
#line 90 "../lib/serializer.vala"
					if (n_digits <= 64) {
#line 91 "../lib/serializer.vala"
						result = s0;
#line 91 "../lib/serializer.vala"
						return result;
#line 358 "serializer.c"
					} else {
						gchar* _tmp2_;
#line 93 "../lib/serializer.vala"
						_tmp2_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 93 "../lib/serializer.vala"
						result = _tmp2_;
#line 93 "../lib/serializer.vala"
						_g_free0 (s0);
#line 93 "../lib/serializer.vala"
						return result;
#line 369 "serializer.c"
					}
				}
#line 86 "../lib/serializer.vala"
				case 8:
#line 374 "serializer.c"
				{
#line 96 "../lib/serializer.vala"
					if (n_digits <= 22) {
#line 97 "../lib/serializer.vala"
						result = s0;
#line 97 "../lib/serializer.vala"
						return result;
#line 382 "serializer.c"
					} else {
						gchar* _tmp3_;
#line 99 "../lib/serializer.vala"
						_tmp3_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 99 "../lib/serializer.vala"
						result = _tmp3_;
#line 99 "../lib/serializer.vala"
						_g_free0 (s0);
#line 99 "../lib/serializer.vala"
						return result;
#line 393 "serializer.c"
					}
				}
#line 86 "../lib/serializer.vala"
				case 16:
#line 398 "serializer.c"
				{
#line 102 "../lib/serializer.vala"
					if (n_digits <= 16) {
#line 103 "../lib/serializer.vala"
						result = s0;
#line 103 "../lib/serializer.vala"
						return result;
#line 406 "serializer.c"
					} else {
						gchar* _tmp4_;
#line 105 "../lib/serializer.vala"
						_tmp4_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 105 "../lib/serializer.vala"
						result = _tmp4_;
#line 105 "../lib/serializer.vala"
						_g_free0 (s0);
#line 105 "../lib/serializer.vala"
						return result;
#line 417 "serializer.c"
					}
				}
				default:
#line 86 "../lib/serializer.vala"
				case 10:
#line 423 "serializer.c"
				{
#line 109 "../lib/serializer.vala"
					if (n_digits <= self->priv->leading_digits) {
#line 110 "../lib/serializer.vala"
						result = s0;
#line 110 "../lib/serializer.vala"
						return result;
#line 431 "serializer.c"
					} else {
						gchar* _tmp5_;
#line 112 "../lib/serializer.vala"
						_tmp5_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 112 "../lib/serializer.vala"
						result = _tmp5_;
#line 112 "../lib/serializer.vala"
						_g_free0 (s0);
#line 112 "../lib/serializer.vala"
						return result;
#line 442 "serializer.c"
					}
				}
			}
#line 79 "../lib/serializer.vala"
			_g_free0 (s0);
#line 448 "serializer.c"
		}
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_FIXED:
#line 452 "serializer.c"
		{
			gint n_digits = 0;
			gchar* _tmp6_;
#line 115 "../lib/serializer.vala"
			n_digits = 0;
#line 116 "../lib/serializer.vala"
			_tmp6_ = serializer_cast_to_string (self, x, &n_digits);
#line 116 "../lib/serializer.vala"
			result = _tmp6_;
#line 116 "../lib/serializer.vala"
			return result;
#line 464 "serializer.c"
		}
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_SCIENTIFIC:
#line 468 "serializer.c"
		{
#line 118 "../lib/serializer.vala"
			if (self->priv->representation_base == ((guint) 10)) {
#line 472 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp7_;
#line 120 "../lib/serializer.vala"
				n_digits = 0;
#line 121 "../lib/serializer.vala"
				_tmp7_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 121 "../lib/serializer.vala"
				result = _tmp7_;
#line 121 "../lib/serializer.vala"
				return result;
#line 483 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp8_;
#line 125 "../lib/serializer.vala"
				n_digits = 0;
#line 126 "../lib/serializer.vala"
				_tmp8_ = serializer_cast_to_string (self, x, &n_digits);
#line 126 "../lib/serializer.vala"
				result = _tmp8_;
#line 126 "../lib/serializer.vala"
				return result;
#line 495 "serializer.c"
			}
		}
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_ENGINEERING:
#line 500 "serializer.c"
		{
#line 129 "../lib/serializer.vala"
			if (self->priv->representation_base == ((guint) 10)) {
#line 504 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp9_;
#line 131 "../lib/serializer.vala"
				n_digits = 0;
#line 132 "../lib/serializer.vala"
				_tmp9_ = serializer_cast_to_exponential_string (self, x, TRUE, &n_digits);
#line 132 "../lib/serializer.vala"
				result = _tmp9_;
#line 132 "../lib/serializer.vala"
				return result;
#line 515 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp10_;
#line 136 "../lib/serializer.vala"
				n_digits = 0;
#line 137 "../lib/serializer.vala"
				_tmp10_ = serializer_cast_to_string (self, x, &n_digits);
#line 137 "../lib/serializer.vala"
				result = _tmp10_;
#line 137 "../lib/serializer.vala"
				return result;
#line 527 "serializer.c"
			}
		}
	}
}

Number*
serializer_from_string (Serializer* self,
                        const gchar* str)
{
	Number* _tmp0_;
	Number* result;
#line 142 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../lib/serializer.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 145 "../lib/serializer.vala"
	_tmp0_ = mp_set_from_string (str, self->priv->number_base);
#line 145 "../lib/serializer.vala"
	result = _tmp0_;
#line 145 "../lib/serializer.vala"
	return result;
#line 549 "serializer.c"
}

void
serializer_set_base (Serializer* self,
                     gint number_base)
{
#line 148 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 150 "../lib/serializer.vala"
	self->priv->number_base = number_base;
#line 560 "serializer.c"
}

gint
serializer_get_base (Serializer* self)
{
	gint result;
#line 153 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 155 "../lib/serializer.vala"
	result = self->priv->number_base;
#line 155 "../lib/serializer.vala"
	return result;
#line 573 "serializer.c"
}

void
serializer_set_representation_base (Serializer* self,
                                    guint representation_base)
{
#line 158 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 160 "../lib/serializer.vala"
	self->priv->representation_base = representation_base;
#line 584 "serializer.c"
}

guint
serializer_get_representation_base (Serializer* self)
{
	guint result;
#line 163 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 165 "../lib/serializer.vala"
	result = self->priv->representation_base;
#line 165 "../lib/serializer.vala"
	return result;
#line 597 "serializer.c"
}

void
serializer_set_radix (Serializer* self,
                      gunichar radix)
{
#line 168 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 170 "../lib/serializer.vala"
	self->priv->radix = radix;
#line 608 "serializer.c"
}

gunichar
serializer_get_radix (Serializer* self)
{
	gunichar result;
#line 173 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 175 "../lib/serializer.vala"
	result = self->priv->radix;
#line 175 "../lib/serializer.vala"
	return result;
#line 621 "serializer.c"
}

void
serializer_set_thousands_separator (Serializer* self,
                                    gunichar separator)
{
#line 178 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 180 "../lib/serializer.vala"
	self->priv->tsep = separator;
#line 632 "serializer.c"
}

gunichar
serializer_get_thousands_separator (Serializer* self)
{
	gunichar result;
#line 183 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 185 "../lib/serializer.vala"
	result = self->priv->tsep;
#line 185 "../lib/serializer.vala"
	return result;
#line 645 "serializer.c"
}

gint
serializer_get_thousands_separator_count (Serializer* self)
{
	gint result;
#line 188 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 190 "../lib/serializer.vala"
	result = self->priv->tsep_count;
#line 190 "../lib/serializer.vala"
	return result;
#line 658 "serializer.c"
}

void
serializer_set_thousands_separator_count (Serializer* self,
                                          gint count)
{
#line 193 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 195 "../lib/serializer.vala"
	self->priv->tsep_count = count;
#line 669 "serializer.c"
}

void
serializer_set_show_thousands_separators (Serializer* self,
                                          gboolean visible)
{
#line 198 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 200 "../lib/serializer.vala"
	self->priv->show_tsep = visible;
#line 680 "serializer.c"
}

gboolean
serializer_get_show_thousands_separators (Serializer* self)
{
	gboolean result;
#line 203 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../lib/serializer.vala"
	result = self->priv->show_tsep;
#line 205 "../lib/serializer.vala"
	return result;
#line 693 "serializer.c"
}

void
serializer_set_show_trailing_zeroes (Serializer* self,
                                     gboolean visible)
{
#line 208 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 210 "../lib/serializer.vala"
	self->priv->show_zeroes = visible;
#line 704 "serializer.c"
}

gboolean
serializer_get_show_trailing_zeroes (Serializer* self)
{
	gboolean result;
#line 213 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "../lib/serializer.vala"
	result = self->priv->show_zeroes;
#line 215 "../lib/serializer.vala"
	return result;
#line 717 "serializer.c"
}

gint
serializer_get_leading_digits (Serializer* self)
{
	gint result;
#line 218 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 220 "../lib/serializer.vala"
	result = self->priv->leading_digits;
#line 220 "../lib/serializer.vala"
	return result;
#line 730 "serializer.c"
}

void
serializer_set_leading_digits (Serializer* self,
                               gint leading_digits)
{
#line 223 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 225 "../lib/serializer.vala"
	self->priv->leading_digits = leading_digits;
#line 741 "serializer.c"
}

gint
serializer_get_trailing_digits (Serializer* self)
{
	gint result;
#line 228 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../lib/serializer.vala"
	result = self->priv->trailing_digits;
#line 230 "../lib/serializer.vala"
	return result;
#line 754 "serializer.c"
}

void
serializer_set_trailing_digits (Serializer* self,
                                gint trailing_digits)
{
#line 233 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 765 "serializer.c"
}

DisplayFormat
serializer_get_number_format (Serializer* self)
{
	DisplayFormat result;
#line 238 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 240 "../lib/serializer.vala"
	result = self->priv->format;
#line 240 "../lib/serializer.vala"
	return result;
#line 778 "serializer.c"
}

void
serializer_set_number_format (Serializer* self,
                              DisplayFormat format)
{
#line 243 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 245 "../lib/serializer.vala"
	self->priv->format = format;
#line 789 "serializer.c"
}

static gchar*
serializer_cast_to_string (Serializer* self,
                           Number* x,
                           gint* n_digits)
{
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	GString* _tmp3_;
	GString* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* result;
#line 248 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 250 "../lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 250 "../lib/serializer.vala"
	string = _tmp0_;
#line 252 "../lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 252 "../lib/serializer.vala"
	x_real = _tmp1_;
#line 253 "../lib/serializer.vala"
	_tmp2_ = x_real;
#line 253 "../lib/serializer.vala"
	_tmp3_ = string;
#line 253 "../lib/serializer.vala"
	serializer_cast_to_string_real (self, _tmp2_, (gint) self->priv->representation_base, FALSE, n_digits, _tmp3_);
#line 254 "../lib/serializer.vala"
	if (number_is_complex (x)) {
#line 827 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp4_;
		gboolean force_sign = FALSE;
		GString* _tmp5_;
		const gchar* _tmp6_;
		GString* s = NULL;
		GString* _tmp8_;
		gint n_complex_digits = 0;
		Number* _tmp9_;
		GString* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 256 "../lib/serializer.vala"
		_tmp4_ = number_imaginary_component (x);
#line 256 "../lib/serializer.vala"
		x_im = _tmp4_;
#line 258 "../lib/serializer.vala"
		force_sign = TRUE;
#line 259 "../lib/serializer.vala"
		_tmp5_ = string;
#line 259 "../lib/serializer.vala"
		_tmp6_ = _tmp5_->str;
#line 259 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp6_, "0") == 0) {
#line 854 "serializer.c"
			GString* _tmp7_;
#line 261 "../lib/serializer.vala"
			_tmp7_ = string;
#line 261 "../lib/serializer.vala"
			g_string_assign (_tmp7_, "");
#line 262 "../lib/serializer.vala"
			force_sign = FALSE;
#line 862 "serializer.c"
		}
#line 265 "../lib/serializer.vala"
		_tmp8_ = g_string_sized_new ((gsize) 1024);
#line 265 "../lib/serializer.vala"
		s = _tmp8_;
#line 266 "../lib/serializer.vala"
		n_complex_digits = 0;
#line 267 "../lib/serializer.vala"
		_tmp9_ = x_im;
#line 267 "../lib/serializer.vala"
		_tmp10_ = s;
#line 267 "../lib/serializer.vala"
		serializer_cast_to_string_real (self, _tmp9_, (gint) self->priv->representation_base, force_sign, &n_complex_digits, _tmp10_);
#line 268 "../lib/serializer.vala"
		if (n_complex_digits > (*n_digits)) {
#line 269 "../lib/serializer.vala"
			*n_digits = n_complex_digits;
#line 880 "serializer.c"
		}
#line 270 "../lib/serializer.vala"
		_tmp13_ = s;
#line 270 "../lib/serializer.vala"
		_tmp14_ = _tmp13_->str;
#line 270 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp14_, "0") == 0) {
#line 270 "../lib/serializer.vala"
			_tmp12_ = TRUE;
#line 890 "serializer.c"
		} else {
			GString* _tmp15_;
			const gchar* _tmp16_;
#line 270 "../lib/serializer.vala"
			_tmp15_ = s;
#line 270 "../lib/serializer.vala"
			_tmp16_ = _tmp15_->str;
#line 270 "../lib/serializer.vala"
			_tmp12_ = g_strcmp0 (_tmp16_, "+0") == 0;
#line 900 "serializer.c"
		}
#line 270 "../lib/serializer.vala"
		if (_tmp12_) {
#line 270 "../lib/serializer.vala"
			_tmp11_ = TRUE;
#line 906 "serializer.c"
		} else {
			GString* _tmp17_;
			const gchar* _tmp18_;
#line 270 "../lib/serializer.vala"
			_tmp17_ = s;
#line 270 "../lib/serializer.vala"
			_tmp18_ = _tmp17_->str;
#line 270 "../lib/serializer.vala"
			_tmp11_ = g_strcmp0 (_tmp18_, "−0") == 0;
#line 916 "serializer.c"
		}
#line 270 "../lib/serializer.vala"
		if (_tmp11_) {
#line 920 "serializer.c"
			GString* _tmp19_;
			const gchar* _tmp20_;
#line 272 "../lib/serializer.vala"
			_tmp19_ = string;
#line 272 "../lib/serializer.vala"
			_tmp20_ = _tmp19_->str;
#line 272 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp20_, "") == 0) {
#line 929 "serializer.c"
				GString* _tmp21_;
#line 274 "../lib/serializer.vala"
				_tmp21_ = string;
#line 274 "../lib/serializer.vala"
				g_string_append (_tmp21_, "0");
#line 935 "serializer.c"
			}
		} else {
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 277 "../lib/serializer.vala"
			_tmp22_ = s;
#line 277 "../lib/serializer.vala"
			_tmp23_ = _tmp22_->str;
#line 277 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp23_, "1") == 0) {
#line 946 "serializer.c"
				GString* _tmp24_;
#line 279 "../lib/serializer.vala"
				_tmp24_ = string;
#line 279 "../lib/serializer.vala"
				g_string_append (_tmp24_, "i");
#line 952 "serializer.c"
			} else {
				GString* _tmp25_;
				const gchar* _tmp26_;
#line 281 "../lib/serializer.vala"
				_tmp25_ = s;
#line 281 "../lib/serializer.vala"
				_tmp26_ = _tmp25_->str;
#line 281 "../lib/serializer.vala"
				if (g_strcmp0 (_tmp26_, "+1") == 0) {
#line 962 "serializer.c"
					GString* _tmp27_;
#line 283 "../lib/serializer.vala"
					_tmp27_ = string;
#line 283 "../lib/serializer.vala"
					g_string_append (_tmp27_, "+i");
#line 968 "serializer.c"
				} else {
					GString* _tmp28_;
					const gchar* _tmp29_;
#line 285 "../lib/serializer.vala"
					_tmp28_ = s;
#line 285 "../lib/serializer.vala"
					_tmp29_ = _tmp28_->str;
#line 285 "../lib/serializer.vala"
					if (g_strcmp0 (_tmp29_, "−1") == 0) {
#line 978 "serializer.c"
						GString* _tmp30_;
#line 287 "../lib/serializer.vala"
						_tmp30_ = string;
#line 287 "../lib/serializer.vala"
						g_string_append (_tmp30_, "−i");
#line 984 "serializer.c"
					} else {
						GString* _tmp31_;
						const gchar* _tmp32_;
						GString* _tmp39_;
#line 291 "../lib/serializer.vala"
						_tmp31_ = s;
#line 291 "../lib/serializer.vala"
						_tmp32_ = _tmp31_->str;
#line 291 "../lib/serializer.vala"
						if (g_strcmp0 (_tmp32_, "+0") == 0) {
#line 995 "serializer.c"
							GString* _tmp33_;
#line 292 "../lib/serializer.vala"
							_tmp33_ = string;
#line 292 "../lib/serializer.vala"
							g_string_append (_tmp33_, "+");
#line 1001 "serializer.c"
						} else {
							GString* _tmp34_;
							const gchar* _tmp35_;
#line 293 "../lib/serializer.vala"
							_tmp34_ = s;
#line 293 "../lib/serializer.vala"
							_tmp35_ = _tmp34_->str;
#line 293 "../lib/serializer.vala"
							if (g_strcmp0 (_tmp35_, "0") != 0) {
#line 1011 "serializer.c"
								GString* _tmp36_;
								GString* _tmp37_;
								const gchar* _tmp38_;
#line 294 "../lib/serializer.vala"
								_tmp36_ = string;
#line 294 "../lib/serializer.vala"
								_tmp37_ = s;
#line 294 "../lib/serializer.vala"
								_tmp38_ = _tmp37_->str;
#line 294 "../lib/serializer.vala"
								g_string_append (_tmp36_, _tmp38_);
#line 1023 "serializer.c"
							}
						}
#line 296 "../lib/serializer.vala"
						_tmp39_ = string;
#line 296 "../lib/serializer.vala"
						g_string_append (_tmp39_, "i");
#line 1030 "serializer.c"
					}
				}
			}
		}
#line 254 "../lib/serializer.vala"
		_g_string_free0 (s);
#line 254 "../lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 1039 "serializer.c"
	}
#line 300 "../lib/serializer.vala"
	_tmp40_ = string;
#line 300 "../lib/serializer.vala"
	_tmp41_ = _tmp40_->str;
#line 300 "../lib/serializer.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 300 "../lib/serializer.vala"
	result = _tmp42_;
#line 300 "../lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 300 "../lib/serializer.vala"
	_g_string_free0 (string);
#line 300 "../lib/serializer.vala"
	return result;
#line 1055 "serializer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 307 "../lib/serializer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1063 "serializer.c"
}

static void
serializer_cast_to_string_real (Serializer* self,
                                Number* x,
                                gint number_base,
                                gboolean force_sign,
                                gint* n_digits,
                                GString* string)
{
#line 305 "../lib/serializer.vala"
	static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 1076 "serializer.c"
	Number* number = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* temp = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* rounded_number = NULL;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	gint i = 0;
	gssize last_non_zero = 0L;
	Number* _tmp36_;
	Number* _tmp37_;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
	const gchar* _tmp52_;
#line 303 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 303 "../lib/serializer.vala"
	g_return_if_fail (x != NULL);
#line 303 "../lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 307 "../lib/serializer.vala"
	_tmp0_ = _g_object_ref0 (x);
#line 307 "../lib/serializer.vala"
	number = _tmp0_;
#line 308 "../lib/serializer.vala"
	_tmp1_ = number;
#line 308 "../lib/serializer.vala"
	if (number_is_negative (_tmp1_)) {
#line 1115 "serializer.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 309 "../lib/serializer.vala"
		_tmp2_ = number;
#line 309 "../lib/serializer.vala"
		_tmp3_ = number_abs (_tmp2_);
#line 309 "../lib/serializer.vala"
		_g_object_unref0 (number);
#line 309 "../lib/serializer.vala"
		number = _tmp3_;
#line 1126 "serializer.c"
	}
#line 312 "../lib/serializer.vala"
	_tmp4_ = number_new_integer ((gint64) number_base, (gint64) 0);
#line 312 "../lib/serializer.vala"
	temp = _tmp4_;
#line 313 "../lib/serializer.vala"
	_tmp5_ = temp;
#line 313 "../lib/serializer.vala"
	_tmp6_ = number_xpowy_integer (_tmp5_, (gint64) (-(self->priv->trailing_digits + 1)));
#line 313 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 313 "../lib/serializer.vala"
	temp = _tmp6_;
#line 314 "../lib/serializer.vala"
	_tmp7_ = temp;
#line 314 "../lib/serializer.vala"
	_tmp8_ = number_multiply_integer (_tmp7_, (gint64) number_base);
#line 314 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 314 "../lib/serializer.vala"
	temp = _tmp8_;
#line 315 "../lib/serializer.vala"
	_tmp9_ = temp;
#line 315 "../lib/serializer.vala"
	_tmp10_ = number_divide_integer (_tmp9_, (gint64) 2);
#line 315 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 315 "../lib/serializer.vala"
	temp = _tmp10_;
#line 316 "../lib/serializer.vala"
	_tmp11_ = number;
#line 316 "../lib/serializer.vala"
	_tmp12_ = temp;
#line 316 "../lib/serializer.vala"
	_tmp13_ = number_add (_tmp11_, _tmp12_);
#line 316 "../lib/serializer.vala"
	rounded_number = _tmp13_;
#line 319 "../lib/serializer.vala"
	_tmp14_ = rounded_number;
#line 319 "../lib/serializer.vala"
	_tmp15_ = number_floor (_tmp14_);
#line 319 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 319 "../lib/serializer.vala"
	temp = _tmp15_;
#line 320 "../lib/serializer.vala"
	i = 0;
#line 1174 "serializer.c"
	{
		gboolean _tmp16_ = FALSE;
#line 321 "../lib/serializer.vala"
		_tmp16_ = TRUE;
#line 321 "../lib/serializer.vala"
		while (TRUE) {
#line 1181 "serializer.c"
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			Number* t = NULL;
			Number* _tmp21_;
			Number* _tmp22_;
			Number* _tmp23_;
			Number* _tmp24_;
			Number* t2 = NULL;
			Number* _tmp25_;
			Number* _tmp26_;
			Number* t3 = NULL;
			Number* _tmp27_;
			Number* _tmp28_;
			Number* _tmp29_;
			gint64 d = 0LL;
			Number* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gint _tmp33_;
			Number* _tmp34_;
			Number* _tmp35_;
#line 321 "../lib/serializer.vala"
			if (!_tmp16_) {
#line 1205 "serializer.c"
				Number* _tmp17_;
#line 352 "../lib/serializer.vala"
				_tmp17_ = temp;
#line 352 "../lib/serializer.vala"
				if (!(!number_is_zero (_tmp17_))) {
#line 352 "../lib/serializer.vala"
					break;
#line 1213 "serializer.c"
				}
			}
#line 321 "../lib/serializer.vala"
			_tmp16_ = FALSE;
#line 323 "../lib/serializer.vala"
			if (number_base == 10) {
#line 323 "../lib/serializer.vala"
				_tmp19_ = self->priv->show_tsep;
#line 1222 "serializer.c"
			} else {
#line 323 "../lib/serializer.vala"
				_tmp19_ = FALSE;
#line 1226 "serializer.c"
			}
#line 323 "../lib/serializer.vala"
			if (_tmp19_) {
#line 323 "../lib/serializer.vala"
				_tmp18_ = i == self->priv->tsep_count;
#line 1232 "serializer.c"
			} else {
#line 323 "../lib/serializer.vala"
				_tmp18_ = FALSE;
#line 1236 "serializer.c"
			}
#line 323 "../lib/serializer.vala"
			if (_tmp18_) {
#line 325 "../lib/serializer.vala"
				g_string_prepend_unichar (string, self->priv->tsep);
#line 326 "../lib/serializer.vala"
				i = 0;
#line 1244 "serializer.c"
			}
#line 328 "../lib/serializer.vala"
			_tmp20_ = i;
#line 328 "../lib/serializer.vala"
			i = _tmp20_ + 1;
#line 330 "../lib/serializer.vala"
			_tmp21_ = temp;
#line 330 "../lib/serializer.vala"
			_tmp22_ = number_divide_integer (_tmp21_, (gint64) number_base);
#line 330 "../lib/serializer.vala"
			t = _tmp22_;
#line 331 "../lib/serializer.vala"
			_tmp23_ = t;
#line 331 "../lib/serializer.vala"
			_tmp24_ = number_floor (_tmp23_);
#line 331 "../lib/serializer.vala"
			_g_object_unref0 (t);
#line 331 "../lib/serializer.vala"
			t = _tmp24_;
#line 332 "../lib/serializer.vala"
			_tmp25_ = t;
#line 332 "../lib/serializer.vala"
			_tmp26_ = number_multiply_integer (_tmp25_, (gint64) number_base);
#line 332 "../lib/serializer.vala"
			t2 = _tmp26_;
#line 334 "../lib/serializer.vala"
			_tmp27_ = temp;
#line 334 "../lib/serializer.vala"
			_tmp28_ = t2;
#line 334 "../lib/serializer.vala"
			_tmp29_ = number_subtract (_tmp27_, _tmp28_);
#line 334 "../lib/serializer.vala"
			t3 = _tmp29_;
#line 336 "../lib/serializer.vala"
			_tmp30_ = t3;
#line 336 "../lib/serializer.vala"
			d = number_to_integer (_tmp30_);
#line 338 "../lib/serializer.vala"
			if (d < ((gint64) 16)) {
#line 338 "../lib/serializer.vala"
				_tmp31_ = d >= ((gint64) 0);
#line 1286 "serializer.c"
			} else {
#line 338 "../lib/serializer.vala"
				_tmp31_ = FALSE;
#line 1290 "serializer.c"
			}
#line 338 "../lib/serializer.vala"
			if (_tmp31_) {
#line 1294 "serializer.c"
				gchar _tmp32_;
#line 340 "../lib/serializer.vala"
				_tmp32_ = digits[d];
#line 340 "../lib/serializer.vala"
				g_string_prepend_c (string, _tmp32_);
#line 1300 "serializer.c"
			} else {
#line 344 "../lib/serializer.vala"
				g_string_prepend_c (string, '?');
#line 345 "../lib/serializer.vala"
				serializer_set_error (self, _ ("Overflow: the result couldn’t be calculated"));
#line 346 "../lib/serializer.vala"
				g_string_assign (string, "0");
#line 347 "../lib/serializer.vala"
				_g_object_unref0 (t3);
#line 347 "../lib/serializer.vala"
				_g_object_unref0 (t2);
#line 347 "../lib/serializer.vala"
				_g_object_unref0 (t);
#line 347 "../lib/serializer.vala"
				break;
#line 1316 "serializer.c"
			}
#line 349 "../lib/serializer.vala"
			_tmp33_ = *n_digits;
#line 349 "../lib/serializer.vala"
			*n_digits = _tmp33_ + 1;
#line 351 "../lib/serializer.vala"
			_tmp34_ = t;
#line 351 "../lib/serializer.vala"
			_tmp35_ = _g_object_ref0 (_tmp34_);
#line 351 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 351 "../lib/serializer.vala"
			temp = _tmp35_;
#line 321 "../lib/serializer.vala"
			_g_object_unref0 (t3);
#line 321 "../lib/serializer.vala"
			_g_object_unref0 (t2);
#line 321 "../lib/serializer.vala"
			_g_object_unref0 (t);
#line 1336 "serializer.c"
		}
	}
#line 354 "../lib/serializer.vala"
	last_non_zero = string->len;
#line 356 "../lib/serializer.vala"
	g_string_append_unichar (string, self->priv->radix);
#line 359 "../lib/serializer.vala"
	_tmp36_ = rounded_number;
#line 359 "../lib/serializer.vala"
	_tmp37_ = number_fractional_component (_tmp36_);
#line 359 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 359 "../lib/serializer.vala"
	temp = _tmp37_;
#line 1351 "serializer.c"
	{
		gboolean _tmp38_ = FALSE;
#line 360 "../lib/serializer.vala"
		i = 0;
#line 360 "../lib/serializer.vala"
		_tmp38_ = TRUE;
#line 360 "../lib/serializer.vala"
		while (TRUE) {
#line 1360 "serializer.c"
			Number* _tmp40_;
			Number* _tmp41_;
			Number* _tmp42_;
			Number* digit = NULL;
			Number* _tmp43_;
			Number* _tmp44_;
			gint64 d = 0LL;
			Number* _tmp45_;
			gchar _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
#line 360 "../lib/serializer.vala"
			if (!_tmp38_) {
#line 1375 "serializer.c"
				gint _tmp39_;
#line 360 "../lib/serializer.vala"
				_tmp39_ = i;
#line 360 "../lib/serializer.vala"
				i = _tmp39_ + 1;
#line 1381 "serializer.c"
			}
#line 360 "../lib/serializer.vala"
			_tmp38_ = FALSE;
#line 360 "../lib/serializer.vala"
			if (!(i < self->priv->trailing_digits)) {
#line 360 "../lib/serializer.vala"
				break;
#line 1389 "serializer.c"
			}
#line 362 "../lib/serializer.vala"
			_tmp40_ = temp;
#line 362 "../lib/serializer.vala"
			if (number_is_zero (_tmp40_)) {
#line 363 "../lib/serializer.vala"
				break;
#line 1397 "serializer.c"
			}
#line 365 "../lib/serializer.vala"
			_tmp41_ = temp;
#line 365 "../lib/serializer.vala"
			_tmp42_ = number_multiply_integer (_tmp41_, (gint64) number_base);
#line 365 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 365 "../lib/serializer.vala"
			temp = _tmp42_;
#line 366 "../lib/serializer.vala"
			_tmp43_ = temp;
#line 366 "../lib/serializer.vala"
			_tmp44_ = number_floor (_tmp43_);
#line 366 "../lib/serializer.vala"
			digit = _tmp44_;
#line 367 "../lib/serializer.vala"
			_tmp45_ = digit;
#line 367 "../lib/serializer.vala"
			d = number_to_integer (_tmp45_);
#line 369 "../lib/serializer.vala"
			_tmp46_ = digits[d];
#line 369 "../lib/serializer.vala"
			g_string_append_c (string, _tmp46_);
#line 371 "../lib/serializer.vala"
			if (d != ((gint64) 0)) {
#line 372 "../lib/serializer.vala"
				last_non_zero = string->len;
#line 1425 "serializer.c"
			}
#line 373 "../lib/serializer.vala"
			_tmp47_ = temp;
#line 373 "../lib/serializer.vala"
			_tmp48_ = digit;
#line 373 "../lib/serializer.vala"
			_tmp49_ = number_subtract (_tmp47_, _tmp48_);
#line 373 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 373 "../lib/serializer.vala"
			temp = _tmp49_;
#line 360 "../lib/serializer.vala"
			_g_object_unref0 (digit);
#line 1439 "serializer.c"
		}
	}
#line 377 "../lib/serializer.vala"
	if (!self->priv->show_zeroes) {
#line 377 "../lib/serializer.vala"
		_tmp50_ = TRUE;
#line 1446 "serializer.c"
	} else {
#line 377 "../lib/serializer.vala"
		_tmp50_ = self->priv->trailing_digits == 0;
#line 1450 "serializer.c"
	}
#line 377 "../lib/serializer.vala"
	if (_tmp50_) {
#line 378 "../lib/serializer.vala"
		g_string_truncate (string, (gsize) last_non_zero);
#line 1456 "serializer.c"
	}
#line 381 "../lib/serializer.vala"
	_tmp52_ = string->str;
#line 381 "../lib/serializer.vala"
	if (g_strcmp0 (_tmp52_, "0") != 0) {
#line 381 "../lib/serializer.vala"
		_tmp51_ = TRUE;
#line 1464 "serializer.c"
	} else {
#line 381 "../lib/serializer.vala"
		_tmp51_ = force_sign;
#line 1468 "serializer.c"
	}
#line 381 "../lib/serializer.vala"
	if (_tmp51_) {
#line 383 "../lib/serializer.vala"
		if (number_is_negative (x)) {
#line 384 "../lib/serializer.vala"
			g_string_prepend (string, "−");
#line 1476 "serializer.c"
		} else {
#line 385 "../lib/serializer.vala"
			if (force_sign) {
#line 386 "../lib/serializer.vala"
				g_string_prepend (string, "+");
#line 1482 "serializer.c"
			}
		}
	}
#line 390 "../lib/serializer.vala"
	if (number_base != self->priv->number_base) {
#line 392 "../lib/serializer.vala"
		static const gchar* sub_digits[10] = {"₀", "₁", "₂", "₃", "₄", "₅", "₆", "₇", "₈", "₉"};
#line 1490 "serializer.c"
		gint multiplier = 0;
		gint b = 0;
#line 393 "../lib/serializer.vala"
		multiplier = 1;
#line 394 "../lib/serializer.vala"
		b = number_base;
#line 396 "../lib/serializer.vala"
		while (TRUE) {
#line 396 "../lib/serializer.vala"
			if (!((number_base / multiplier) != 0)) {
#line 396 "../lib/serializer.vala"
				break;
#line 1503 "serializer.c"
			}
#line 397 "../lib/serializer.vala"
			multiplier *= 10;
#line 1507 "serializer.c"
		}
#line 398 "../lib/serializer.vala"
		while (TRUE) {
#line 1511 "serializer.c"
			gint d = 0;
			const gchar* _tmp53_;
#line 398 "../lib/serializer.vala"
			if (!(multiplier != 1)) {
#line 398 "../lib/serializer.vala"
				break;
#line 1518 "serializer.c"
			}
#line 401 "../lib/serializer.vala"
			multiplier /= 10;
#line 402 "../lib/serializer.vala"
			d = b / multiplier;
#line 403 "../lib/serializer.vala"
			_tmp53_ = sub_digits[d];
#line 403 "../lib/serializer.vala"
			g_string_append (string, _tmp53_);
#line 404 "../lib/serializer.vala"
			b -= d * multiplier;
#line 1530 "serializer.c"
		}
	}
#line 303 "../lib/serializer.vala"
	_g_object_unref0 (rounded_number);
#line 303 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 303 "../lib/serializer.vala"
	_g_object_unref0 (number);
#line 1539 "serializer.c"
}

static gint
serializer_cast_to_exponential_string_real (Serializer* self,
                                            Number* x,
                                            GString* string,
                                            gboolean eng_format,
                                            gint* n_digits)
{
	Number* mantissa = NULL;
	Number* _tmp0_;
	Number* base_ = NULL;
	Number* _tmp1_;
	Number* base3 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* base10 = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t = NULL;
	Number* _tmp6_;
	Number* base10inv = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	gint exponent = 0;
	Number* _tmp10_;
	Number* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gint result;
#line 409 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 409 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, 0);
#line 409 "../lib/serializer.vala"
	g_return_val_if_fail (string != NULL, 0);
#line 411 "../lib/serializer.vala"
	if (number_is_negative (x)) {
#line 412 "../lib/serializer.vala"
		g_string_append (string, "−");
#line 1581 "serializer.c"
	}
#line 414 "../lib/serializer.vala"
	_tmp0_ = number_abs (x);
#line 414 "../lib/serializer.vala"
	mantissa = _tmp0_;
#line 416 "../lib/serializer.vala"
	_tmp1_ = number_new_integer ((gint64) self->priv->number_base, (gint64) 0);
#line 416 "../lib/serializer.vala"
	base_ = _tmp1_;
#line 417 "../lib/serializer.vala"
	_tmp2_ = base_;
#line 417 "../lib/serializer.vala"
	_tmp3_ = number_xpowy_integer (_tmp2_, (gint64) 3);
#line 417 "../lib/serializer.vala"
	base3 = _tmp3_;
#line 418 "../lib/serializer.vala"
	_tmp4_ = base_;
#line 418 "../lib/serializer.vala"
	_tmp5_ = number_xpowy_integer (_tmp4_, (gint64) 10);
#line 418 "../lib/serializer.vala"
	base10 = _tmp5_;
#line 419 "../lib/serializer.vala"
	_tmp6_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 419 "../lib/serializer.vala"
	t = _tmp6_;
#line 420 "../lib/serializer.vala"
	_tmp7_ = t;
#line 420 "../lib/serializer.vala"
	_tmp8_ = base10;
#line 420 "../lib/serializer.vala"
	_tmp9_ = number_divide (_tmp7_, _tmp8_);
#line 420 "../lib/serializer.vala"
	base10inv = _tmp9_;
#line 422 "../lib/serializer.vala"
	exponent = 0;
#line 423 "../lib/serializer.vala"
	_tmp10_ = mantissa;
#line 423 "../lib/serializer.vala"
	if (!number_is_zero (_tmp10_)) {
#line 1621 "serializer.c"
		Number* _tmp34_;
#line 425 "../lib/serializer.vala"
		while (TRUE) {
#line 1625 "serializer.c"
			gboolean _tmp11_ = FALSE;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 425 "../lib/serializer.vala"
			if (!eng_format) {
#line 1632 "serializer.c"
				Number* _tmp12_;
				Number* _tmp13_;
#line 425 "../lib/serializer.vala"
				_tmp12_ = mantissa;
#line 425 "../lib/serializer.vala"
				_tmp13_ = base10;
#line 425 "../lib/serializer.vala"
				_tmp11_ = number_compare (_tmp12_, _tmp13_) >= 0;
#line 1641 "serializer.c"
			} else {
#line 425 "../lib/serializer.vala"
				_tmp11_ = FALSE;
#line 1645 "serializer.c"
			}
#line 425 "../lib/serializer.vala"
			if (!_tmp11_) {
#line 425 "../lib/serializer.vala"
				break;
#line 1651 "serializer.c"
			}
#line 427 "../lib/serializer.vala"
			exponent += 10;
#line 428 "../lib/serializer.vala"
			_tmp14_ = mantissa;
#line 428 "../lib/serializer.vala"
			_tmp15_ = base10inv;
#line 428 "../lib/serializer.vala"
			_tmp16_ = number_multiply (_tmp14_, _tmp15_);
#line 428 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 428 "../lib/serializer.vala"
			mantissa = _tmp16_;
#line 1665 "serializer.c"
		}
#line 431 "../lib/serializer.vala"
		while (TRUE) {
#line 1669 "serializer.c"
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			Number* _tmp25_;
			Number* _tmp26_;
			Number* _tmp27_;
#line 431 "../lib/serializer.vala"
			if (!eng_format) {
#line 1677 "serializer.c"
				Number* _tmp19_;
				Number* _tmp20_;
#line 431 "../lib/serializer.vala"
				_tmp19_ = mantissa;
#line 431 "../lib/serializer.vala"
				_tmp20_ = base_;
#line 431 "../lib/serializer.vala"
				_tmp18_ = number_compare (_tmp19_, _tmp20_) >= 0;
#line 1686 "serializer.c"
			} else {
#line 431 "../lib/serializer.vala"
				_tmp18_ = FALSE;
#line 1690 "serializer.c"
			}
#line 431 "../lib/serializer.vala"
			if (_tmp18_) {
#line 431 "../lib/serializer.vala"
				_tmp17_ = TRUE;
#line 1696 "serializer.c"
			} else {
				gboolean _tmp21_ = FALSE;
#line 432 "../lib/serializer.vala"
				if (eng_format) {
#line 1701 "serializer.c"
					gboolean _tmp22_ = FALSE;
					Number* _tmp23_;
					Number* _tmp24_;
#line 432 "../lib/serializer.vala"
					_tmp23_ = mantissa;
#line 432 "../lib/serializer.vala"
					_tmp24_ = base3;
#line 432 "../lib/serializer.vala"
					if (number_compare (_tmp23_, _tmp24_) >= 0) {
#line 432 "../lib/serializer.vala"
						_tmp22_ = TRUE;
#line 1713 "serializer.c"
					} else {
#line 432 "../lib/serializer.vala"
						_tmp22_ = (exponent % 3) != 0;
#line 1717 "serializer.c"
					}
#line 432 "../lib/serializer.vala"
					_tmp21_ = _tmp22_;
#line 1721 "serializer.c"
				} else {
#line 432 "../lib/serializer.vala"
					_tmp21_ = FALSE;
#line 1725 "serializer.c"
				}
#line 432 "../lib/serializer.vala"
				_tmp17_ = _tmp21_;
#line 1729 "serializer.c"
			}
#line 431 "../lib/serializer.vala"
			if (!_tmp17_) {
#line 431 "../lib/serializer.vala"
				break;
#line 1735 "serializer.c"
			}
#line 434 "../lib/serializer.vala"
			exponent += 1;
#line 435 "../lib/serializer.vala"
			_tmp25_ = mantissa;
#line 435 "../lib/serializer.vala"
			_tmp26_ = base_;
#line 435 "../lib/serializer.vala"
			_tmp27_ = number_divide (_tmp25_, _tmp26_);
#line 435 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 435 "../lib/serializer.vala"
			mantissa = _tmp27_;
#line 1749 "serializer.c"
		}
#line 438 "../lib/serializer.vala"
		while (TRUE) {
#line 1753 "serializer.c"
			gboolean _tmp28_ = FALSE;
			Number* _tmp31_;
			Number* _tmp32_;
			Number* _tmp33_;
#line 438 "../lib/serializer.vala"
			if (!eng_format) {
#line 1760 "serializer.c"
				Number* _tmp29_;
				Number* _tmp30_;
#line 438 "../lib/serializer.vala"
				_tmp29_ = mantissa;
#line 438 "../lib/serializer.vala"
				_tmp30_ = base10inv;
#line 438 "../lib/serializer.vala"
				_tmp28_ = number_compare (_tmp29_, _tmp30_) < 0;
#line 1769 "serializer.c"
			} else {
#line 438 "../lib/serializer.vala"
				_tmp28_ = FALSE;
#line 1773 "serializer.c"
			}
#line 438 "../lib/serializer.vala"
			if (!_tmp28_) {
#line 438 "../lib/serializer.vala"
				break;
#line 1779 "serializer.c"
			}
#line 440 "../lib/serializer.vala"
			exponent -= 10;
#line 441 "../lib/serializer.vala"
			_tmp31_ = mantissa;
#line 441 "../lib/serializer.vala"
			_tmp32_ = base10;
#line 441 "../lib/serializer.vala"
			_tmp33_ = number_multiply (_tmp31_, _tmp32_);
#line 441 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 441 "../lib/serializer.vala"
			mantissa = _tmp33_;
#line 1793 "serializer.c"
		}
#line 444 "../lib/serializer.vala"
		_tmp34_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 444 "../lib/serializer.vala"
		_g_object_unref0 (t);
#line 444 "../lib/serializer.vala"
		t = _tmp34_;
#line 445 "../lib/serializer.vala"
		while (TRUE) {
#line 1803 "serializer.c"
			gboolean _tmp35_ = FALSE;
			Number* _tmp36_;
			Number* _tmp37_;
			Number* _tmp39_;
			Number* _tmp40_;
			Number* _tmp41_;
#line 445 "../lib/serializer.vala"
			_tmp36_ = mantissa;
#line 445 "../lib/serializer.vala"
			_tmp37_ = t;
#line 445 "../lib/serializer.vala"
			if (number_compare (_tmp36_, _tmp37_) < 0) {
#line 445 "../lib/serializer.vala"
				_tmp35_ = TRUE;
#line 1818 "serializer.c"
			} else {
				gboolean _tmp38_ = FALSE;
#line 445 "../lib/serializer.vala"
				if (eng_format) {
#line 445 "../lib/serializer.vala"
					_tmp38_ = (exponent % 3) != 0;
#line 1825 "serializer.c"
				} else {
#line 445 "../lib/serializer.vala"
					_tmp38_ = FALSE;
#line 1829 "serializer.c"
				}
#line 445 "../lib/serializer.vala"
				_tmp35_ = _tmp38_;
#line 1833 "serializer.c"
			}
#line 445 "../lib/serializer.vala"
			if (!_tmp35_) {
#line 445 "../lib/serializer.vala"
				break;
#line 1839 "serializer.c"
			}
#line 447 "../lib/serializer.vala"
			exponent -= 1;
#line 448 "../lib/serializer.vala"
			_tmp39_ = mantissa;
#line 448 "../lib/serializer.vala"
			_tmp40_ = base_;
#line 448 "../lib/serializer.vala"
			_tmp41_ = number_multiply (_tmp39_, _tmp40_);
#line 448 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 448 "../lib/serializer.vala"
			mantissa = _tmp41_;
#line 1853 "serializer.c"
		}
	}
#line 452 "../lib/serializer.vala"
	_tmp42_ = mantissa;
#line 452 "../lib/serializer.vala"
	_tmp43_ = serializer_cast_to_string (self, _tmp42_, n_digits);
#line 452 "../lib/serializer.vala"
	_tmp44_ = _tmp43_;
#line 452 "../lib/serializer.vala"
	g_string_append (string, _tmp44_);
#line 452 "../lib/serializer.vala"
	_g_free0 (_tmp44_);
#line 454 "../lib/serializer.vala"
	result = exponent;
#line 454 "../lib/serializer.vala"
	_g_object_unref0 (base10inv);
#line 454 "../lib/serializer.vala"
	_g_object_unref0 (t);
#line 454 "../lib/serializer.vala"
	_g_object_unref0 (base10);
#line 454 "../lib/serializer.vala"
	_g_object_unref0 (base3);
#line 454 "../lib/serializer.vala"
	_g_object_unref0 (base_);
#line 454 "../lib/serializer.vala"
	_g_object_unref0 (mantissa);
#line 454 "../lib/serializer.vala"
	return result;
#line 1882 "serializer.c"
}

static gchar*
serializer_cast_to_exponential_string (Serializer* self,
                                       Number* x,
                                       gboolean eng_format,
                                       gint* n_digits)
{
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	gint exponent = 0;
	Number* _tmp2_;
	GString* _tmp3_;
	gint _tmp4_;
	GString* _tmp5_;
	GString* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* result;
#line 457 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 457 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 459 "../lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 459 "../lib/serializer.vala"
	string = _tmp0_;
#line 461 "../lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 461 "../lib/serializer.vala"
	x_real = _tmp1_;
#line 462 "../lib/serializer.vala"
	_tmp2_ = x_real;
#line 462 "../lib/serializer.vala"
	_tmp3_ = string;
#line 462 "../lib/serializer.vala"
	_tmp4_ = serializer_cast_to_exponential_string_real (self, _tmp2_, _tmp3_, eng_format, n_digits);
#line 462 "../lib/serializer.vala"
	exponent = _tmp4_;
#line 463 "../lib/serializer.vala"
	_tmp5_ = string;
#line 463 "../lib/serializer.vala"
	serializer_append_exponent (self, _tmp5_, exponent);
#line 465 "../lib/serializer.vala"
	if (number_is_complex (x)) {
#line 1930 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp6_;
		GString* _tmp7_;
		const gchar* _tmp8_;
		GString* s = NULL;
		GString* _tmp10_;
		gint n_complex_digits = 0;
		Number* _tmp11_;
		GString* _tmp12_;
		gint _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GString* _tmp16_;
		const gchar* _tmp17_;
		GString* _tmp40_;
#line 467 "../lib/serializer.vala"
		_tmp6_ = number_imaginary_component (x);
#line 467 "../lib/serializer.vala"
		x_im = _tmp6_;
#line 469 "../lib/serializer.vala"
		_tmp7_ = string;
#line 469 "../lib/serializer.vala"
		_tmp8_ = _tmp7_->str;
#line 469 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp8_, "0") == 0) {
#line 1956 "serializer.c"
			GString* _tmp9_;
#line 470 "../lib/serializer.vala"
			_tmp9_ = string;
#line 470 "../lib/serializer.vala"
			g_string_assign (_tmp9_, "");
#line 1962 "serializer.c"
		}
#line 472 "../lib/serializer.vala"
		_tmp10_ = g_string_sized_new ((gsize) 1024);
#line 472 "../lib/serializer.vala"
		s = _tmp10_;
#line 473 "../lib/serializer.vala"
		n_complex_digits = 0;
#line 474 "../lib/serializer.vala"
		_tmp11_ = x_im;
#line 474 "../lib/serializer.vala"
		_tmp12_ = s;
#line 474 "../lib/serializer.vala"
		_tmp13_ = serializer_cast_to_exponential_string_real (self, _tmp11_, _tmp12_, eng_format, &n_complex_digits);
#line 474 "../lib/serializer.vala"
		exponent = _tmp13_;
#line 475 "../lib/serializer.vala"
		if (n_complex_digits > (*n_digits)) {
#line 476 "../lib/serializer.vala"
			*n_digits = n_complex_digits;
#line 1982 "serializer.c"
		}
#line 477 "../lib/serializer.vala"
		_tmp16_ = s;
#line 477 "../lib/serializer.vala"
		_tmp17_ = _tmp16_->str;
#line 477 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp17_, "0") == 0) {
#line 477 "../lib/serializer.vala"
			_tmp15_ = TRUE;
#line 1992 "serializer.c"
		} else {
			GString* _tmp18_;
			const gchar* _tmp19_;
#line 477 "../lib/serializer.vala"
			_tmp18_ = s;
#line 477 "../lib/serializer.vala"
			_tmp19_ = _tmp18_->str;
#line 477 "../lib/serializer.vala"
			_tmp15_ = g_strcmp0 (_tmp19_, "+0") == 0;
#line 2002 "serializer.c"
		}
#line 477 "../lib/serializer.vala"
		if (_tmp15_) {
#line 477 "../lib/serializer.vala"
			_tmp14_ = TRUE;
#line 2008 "serializer.c"
		} else {
			GString* _tmp20_;
			const gchar* _tmp21_;
#line 477 "../lib/serializer.vala"
			_tmp20_ = s;
#line 477 "../lib/serializer.vala"
			_tmp21_ = _tmp20_->str;
#line 477 "../lib/serializer.vala"
			_tmp14_ = g_strcmp0 (_tmp21_, "−0") == 0;
#line 2018 "serializer.c"
		}
#line 477 "../lib/serializer.vala"
		if (_tmp14_) {
#line 2022 "serializer.c"
		} else {
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 481 "../lib/serializer.vala"
			_tmp22_ = s;
#line 481 "../lib/serializer.vala"
			_tmp23_ = _tmp22_->str;
#line 481 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp23_, "1") == 0) {
#line 2032 "serializer.c"
				GString* _tmp24_;
#line 483 "../lib/serializer.vala"
				_tmp24_ = string;
#line 483 "../lib/serializer.vala"
				g_string_append (_tmp24_, "i");
#line 2038 "serializer.c"
			} else {
				GString* _tmp25_;
				const gchar* _tmp26_;
#line 485 "../lib/serializer.vala"
				_tmp25_ = s;
#line 485 "../lib/serializer.vala"
				_tmp26_ = _tmp25_->str;
#line 485 "../lib/serializer.vala"
				if (g_strcmp0 (_tmp26_, "+1") == 0) {
#line 2048 "serializer.c"
					GString* _tmp27_;
#line 487 "../lib/serializer.vala"
					_tmp27_ = string;
#line 487 "../lib/serializer.vala"
					g_string_append (_tmp27_, "+i");
#line 2054 "serializer.c"
				} else {
					GString* _tmp28_;
					const gchar* _tmp29_;
#line 489 "../lib/serializer.vala"
					_tmp28_ = s;
#line 489 "../lib/serializer.vala"
					_tmp29_ = _tmp28_->str;
#line 489 "../lib/serializer.vala"
					if (g_strcmp0 (_tmp29_, "−1") == 0) {
#line 2064 "serializer.c"
						GString* _tmp30_;
#line 491 "../lib/serializer.vala"
						_tmp30_ = string;
#line 491 "../lib/serializer.vala"
						g_string_append (_tmp30_, "−i");
#line 2070 "serializer.c"
					} else {
						GString* _tmp31_;
						const gchar* _tmp32_;
						GString* _tmp39_;
#line 495 "../lib/serializer.vala"
						_tmp31_ = s;
#line 495 "../lib/serializer.vala"
						_tmp32_ = _tmp31_->str;
#line 495 "../lib/serializer.vala"
						if (g_strcmp0 (_tmp32_, "+0") == 0) {
#line 2081 "serializer.c"
							GString* _tmp33_;
#line 496 "../lib/serializer.vala"
							_tmp33_ = string;
#line 496 "../lib/serializer.vala"
							g_string_append (_tmp33_, "+");
#line 2087 "serializer.c"
						} else {
							GString* _tmp34_;
							const gchar* _tmp35_;
#line 497 "../lib/serializer.vala"
							_tmp34_ = s;
#line 497 "../lib/serializer.vala"
							_tmp35_ = _tmp34_->str;
#line 497 "../lib/serializer.vala"
							if (g_strcmp0 (_tmp35_, "0") != 0) {
#line 2097 "serializer.c"
								GString* _tmp36_;
								GString* _tmp37_;
								const gchar* _tmp38_;
#line 498 "../lib/serializer.vala"
								_tmp36_ = string;
#line 498 "../lib/serializer.vala"
								_tmp37_ = s;
#line 498 "../lib/serializer.vala"
								_tmp38_ = _tmp37_->str;
#line 498 "../lib/serializer.vala"
								g_string_append (_tmp36_, _tmp38_);
#line 2109 "serializer.c"
							}
						}
#line 500 "../lib/serializer.vala"
						_tmp39_ = string;
#line 500 "../lib/serializer.vala"
						g_string_append (_tmp39_, "i");
#line 2116 "serializer.c"
					}
				}
			}
		}
#line 502 "../lib/serializer.vala"
		_tmp40_ = string;
#line 502 "../lib/serializer.vala"
		serializer_append_exponent (self, _tmp40_, exponent);
#line 465 "../lib/serializer.vala"
		_g_string_free0 (s);
#line 465 "../lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 2129 "serializer.c"
	}
#line 505 "../lib/serializer.vala"
	_tmp41_ = string;
#line 505 "../lib/serializer.vala"
	_tmp42_ = _tmp41_->str;
#line 505 "../lib/serializer.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 505 "../lib/serializer.vala"
	result = _tmp43_;
#line 505 "../lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 505 "../lib/serializer.vala"
	_g_string_free0 (string);
#line 505 "../lib/serializer.vala"
	return result;
#line 2145 "serializer.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 2162 "serializer.c"
}

static void
serializer_append_exponent (Serializer* self,
                            GString* string,
                            gint exponent)
{
#line 510 "../lib/serializer.vala"
	static const gunichar super_digits[10] = {8304U, 185U, 178U, 179U, 8308U, 8309U, 8310U, 8311U, 8312U, 8313U};
#line 2172 "serializer.c"
	gchar* super_value = NULL;
	gchar* _tmp0_;
#line 508 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 508 "../lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 512 "../lib/serializer.vala"
	if (exponent == 0) {
#line 513 "../lib/serializer.vala"
		return;
#line 2183 "serializer.c"
	}
#line 515 "../lib/serializer.vala"
	g_string_append (string, "×10");
#line 516 "../lib/serializer.vala"
	if (exponent < 0) {
#line 518 "../lib/serializer.vala"
		exponent = -exponent;
#line 519 "../lib/serializer.vala"
		g_string_append_unichar (string, 8315U);
#line 2193 "serializer.c"
	}
#line 522 "../lib/serializer.vala"
	_tmp0_ = g_strdup_printf ("%d", exponent);
#line 522 "../lib/serializer.vala"
	super_value = _tmp0_;
#line 2199 "serializer.c"
	{
		gint i = 0;
#line 523 "../lib/serializer.vala"
		i = 0;
#line 2204 "serializer.c"
		{
			gboolean _tmp1_ = FALSE;
#line 523 "../lib/serializer.vala"
			_tmp1_ = TRUE;
#line 523 "../lib/serializer.vala"
			while (TRUE) {
#line 2211 "serializer.c"
				const gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				const gchar* _tmp6_;
				gunichar _tmp7_;
#line 523 "../lib/serializer.vala"
				if (!_tmp1_) {
#line 2219 "serializer.c"
					gint _tmp2_;
#line 523 "../lib/serializer.vala"
					_tmp2_ = i;
#line 523 "../lib/serializer.vala"
					i = _tmp2_ + 1;
#line 2225 "serializer.c"
				}
#line 523 "../lib/serializer.vala"
				_tmp1_ = FALSE;
#line 523 "../lib/serializer.vala"
				_tmp3_ = super_value;
#line 523 "../lib/serializer.vala"
				_tmp4_ = strlen (_tmp3_);
#line 523 "../lib/serializer.vala"
				_tmp5_ = _tmp4_;
#line 523 "../lib/serializer.vala"
				if (!(i < _tmp5_)) {
#line 523 "../lib/serializer.vala"
					break;
#line 2239 "serializer.c"
				}
#line 524 "../lib/serializer.vala"
				_tmp6_ = super_value;
#line 524 "../lib/serializer.vala"
				_tmp7_ = super_digits[string_get (_tmp6_, (glong) i) - '0'];
#line 524 "../lib/serializer.vala"
				g_string_append_unichar (string, _tmp7_);
#line 2247 "serializer.c"
			}
		}
	}
#line 508 "../lib/serializer.vala"
	_g_free0 (super_value);
#line 2253 "serializer.c"
}

const gchar*
serializer_get_error (Serializer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../lib/serializer.vala"
	_tmp0_ = self->priv->_error;
#line 36 "../lib/serializer.vala"
	result = _tmp0_;
#line 36 "../lib/serializer.vala"
	return result;
#line 2269 "serializer.c"
}

void
serializer_set_error (Serializer* self,
                      const gchar* value)
{
	gchar* old_value;
#line 36 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 36 "../lib/serializer.vala"
	old_value = serializer_get_error (self);
#line 36 "../lib/serializer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2283 "serializer.c"
		gchar* _tmp0_;
#line 36 "../lib/serializer.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../lib/serializer.vala"
		_g_free0 (self->priv->_error);
#line 36 "../lib/serializer.vala"
		self->priv->_error = _tmp0_;
#line 36 "../lib/serializer.vala"
		g_object_notify_by_pspec ((GObject *) self, serializer_properties[SERIALIZER_ERROR_PROPERTY]);
#line 2293 "serializer.c"
	}
}

static void
serializer_class_init (SerializerClass * klass,
                       gpointer klass_data)
{
#line 20 "../lib/serializer.vala"
	serializer_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/serializer.vala"
	g_type_class_adjust_private_offset (klass, &Serializer_private_offset);
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_serializer_get_property;
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_serializer_set_property;
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->finalize = serializer_finalize;
#line 20 "../lib/serializer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERIALIZER_ERROR_PROPERTY, serializer_properties[SERIALIZER_ERROR_PROPERTY] = g_param_spec_string ("error", "error", "error", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2313 "serializer.c"
}

static void
serializer_instance_init (Serializer * self,
                          gpointer klass)
{
#line 20 "../lib/serializer.vala"
	self->priv = serializer_get_instance_private (self);
#line 36 "../lib/serializer.vala"
	self->priv->_error = NULL;
#line 2324 "serializer.c"
}

static void
serializer_finalize (GObject * obj)
{
	Serializer * self;
#line 20 "../lib/serializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERIALIZER, Serializer);
#line 36 "../lib/serializer.vala"
	_g_free0 (self->priv->_error);
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (serializer_parent_class)->finalize (obj);
#line 2337 "serializer.c"
}

static GType
serializer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SerializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) serializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Serializer), 0, (GInstanceInitFunc) serializer_instance_init, NULL };
	GType serializer_type_id;
	serializer_type_id = g_type_register_static (G_TYPE_OBJECT, "Serializer", &g_define_type_info, 0);
	Serializer_private_offset = g_type_add_instance_private (serializer_type_id, sizeof (SerializerPrivate));
	return serializer_type_id;
}

GType
serializer_get_type (void)
{
	static volatile gsize serializer_type_id__once = 0;
	if (g_once_init_enter (&serializer_type_id__once)) {
		GType serializer_type_id;
		serializer_type_id = serializer_get_type_once ();
		g_once_init_leave (&serializer_type_id__once, serializer_type_id);
	}
	return serializer_type_id__once;
}

static void
_vala_serializer_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "../lib/serializer.vala"
	switch (property_id) {
#line 20 "../lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "../lib/serializer.vala"
		g_value_set_string (value, serializer_get_error (self));
#line 20 "../lib/serializer.vala"
		break;
#line 2378 "serializer.c"
		default:
#line 20 "../lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/serializer.vala"
		break;
#line 2384 "serializer.c"
	}
}

static void
_vala_serializer_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "../lib/serializer.vala"
	switch (property_id) {
#line 20 "../lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "../lib/serializer.vala"
		serializer_set_error (self, g_value_get_string (value));
#line 20 "../lib/serializer.vala"
		break;
#line 2404 "serializer.c"
		default:
#line 20 "../lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/serializer.vala"
		break;
#line 2410 "serializer.c"
	}
}

